
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2013 - 2018 Aleksander Morgado <aleksander@aleksander.es>
 */


#include <string.h>

#include "mbim-sms.h"
#include "mbim-message-private.h"
#include "mbim-enum-types.h"
#include "mbim-error-types.h"
#include "mbim-device.h"
#include "mbim-utils.h"

/*****************************************************************************/
/* Struct: MbimSmsPduReadRecord */

static void
_mbim_sms_pdu_read_record_free (MbimSmsPduReadRecord *var)
{
    if (!var)
        return;

    g_free (var->pdu_data);
    g_free (var);
}

/**
 * mbim_sms_pdu_read_record_array_free:
 * @array: a #NULL terminated array of #MbimSmsPduReadRecord structs.
 *
 * Frees the memory allocated for the array of #MbimSmsPduReadRecords.
 */
void
mbim_sms_pdu_read_record_array_free (MbimSmsPduReadRecord **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_sms_pdu_read_record_free (array[i]);
    g_free (array);
}

static MbimSmsPduReadRecord *
_mbim_message_read_mbim_sms_pdu_read_record_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimSmsPduReadRecord *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimSmsPduReadRecord, 1);

    out->message_index = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->message_status = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    {
        const guint8 *tmp;

        tmp = _mbim_message_read_byte_array (self, relative_offset, offset, TRUE, TRUE, &(out->pdu_data_size));
        out->pdu_data = g_malloc (out->pdu_data_size);
        memcpy (out->pdu_data, tmp, out->pdu_data_size);
        offset += 8;
    }

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimSmsPduReadRecord **
_mbim_message_read_mbim_sms_pdu_read_record_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimSmsPduReadRecord **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimSmsPduReadRecord *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_sms_pdu_read_record_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_sms_pdu_read_record_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_sms_pdu_read_record_struct (
    const MbimSmsPduReadRecord *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  MessageIndex = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->message_index);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  MessageStatus = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->message_status);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  PduData = ", line_prefix);
    {
        guint i;
        guint array_size;

        array_size = self->pdu_data_size;
        g_string_append (str, "'");
        for (i = 0; i < array_size; i++)
            g_string_append_printf (str, "%02x%s", self->pdu_data[i], (i == (array_size - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_sms_pdu_read_record_struct_new (const MbimSmsPduReadRecord *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->message_index);
    _mbim_struct_builder_append_guint32 (builder, value->message_status);
    _mbim_struct_builder_append_byte_array (builder, TRUE, TRUE, TRUE, value->pdu_data, value->pdu_data_size);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_sms_pdu_read_record_struct (
    MbimStructBuilder *builder,
    const MbimSmsPduReadRecord *value)
{
    GByteArray *raw;

    raw = _mbim_sms_pdu_read_record_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_sms_pdu_read_record_struct (
    MbimMessageCommandBuilder *builder,
    const MbimSmsPduReadRecord *value)
{
    _mbim_struct_builder_append_mbim_sms_pdu_read_record_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_sms_pdu_read_record_struct_array (
    MbimStructBuilder *builder,
    const MbimSmsPduReadRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_sms_pdu_read_record_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_sms_pdu_read_record_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_sms_pdu_read_record_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimSmsPduReadRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_sms_pdu_read_record_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimSmsCdmaReadRecord */

static void
_mbim_sms_cdma_read_record_free (MbimSmsCdmaReadRecord *var)
{
    if (!var)
        return;

    g_free (var->address);
    g_free (var->timestamp);
    g_free (var->encoded_message);
    g_free (var);
}

/**
 * mbim_sms_cdma_read_record_array_free:
 * @array: a #NULL terminated array of #MbimSmsCdmaReadRecord structs.
 *
 * Frees the memory allocated for the array of #MbimSmsCdmaReadRecords.
 */
void
mbim_sms_cdma_read_record_array_free (MbimSmsCdmaReadRecord **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_sms_cdma_read_record_free (array[i]);
    g_free (array);
}

static MbimSmsCdmaReadRecord *
_mbim_message_read_mbim_sms_cdma_read_record_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimSmsCdmaReadRecord *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimSmsCdmaReadRecord, 1);

    out->message_index = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->message_status = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->address = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->timestamp = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->encoding = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->language = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    {
        const guint8 *tmp;

        tmp = _mbim_message_read_byte_array (self, relative_offset, offset, TRUE, TRUE, &(out->encoded_message_size));
        out->encoded_message = g_malloc (out->encoded_message_size);
        memcpy (out->encoded_message, tmp, out->encoded_message_size);
        offset += 8;
    }

    out->encoded_message_size_in_characters = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimSmsCdmaReadRecord **
_mbim_message_read_mbim_sms_cdma_read_record_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimSmsCdmaReadRecord **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimSmsCdmaReadRecord *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_sms_cdma_read_record_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_sms_cdma_read_record_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_sms_cdma_read_record_struct (
    const MbimSmsCdmaReadRecord *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  MessageIndex = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->message_index);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  MessageStatus = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->message_status);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Address = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->address);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Timestamp = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->timestamp);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Encoding = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->encoding);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Language = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->language);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  EncodedMessage = ", line_prefix);
    {
        guint i;
        guint array_size;

        array_size = self->encoded_message_size;
        g_string_append (str, "'");
        for (i = 0; i < array_size; i++)
            g_string_append_printf (str, "%02x%s", self->encoded_message[i], (i == (array_size - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  EncodedMessageSizeInCharacters = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->encoded_message_size_in_characters);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_sms_cdma_read_record_struct_new (const MbimSmsCdmaReadRecord *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->message_index);
    _mbim_struct_builder_append_guint32 (builder, value->message_status);
    _mbim_struct_builder_append_string (builder, value->address);
    _mbim_struct_builder_append_string (builder, value->timestamp);
    _mbim_struct_builder_append_guint32 (builder, value->encoding);
    _mbim_struct_builder_append_guint32 (builder, value->language);
    _mbim_struct_builder_append_byte_array (builder, TRUE, TRUE, TRUE, value->encoded_message, value->encoded_message_size);
    _mbim_struct_builder_append_guint32 (builder, value->encoded_message_size_in_characters);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_sms_cdma_read_record_struct (
    MbimStructBuilder *builder,
    const MbimSmsCdmaReadRecord *value)
{
    GByteArray *raw;

    raw = _mbim_sms_cdma_read_record_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_sms_cdma_read_record_struct (
    MbimMessageCommandBuilder *builder,
    const MbimSmsCdmaReadRecord *value)
{
    _mbim_struct_builder_append_mbim_sms_cdma_read_record_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_sms_cdma_read_record_struct_array (
    MbimStructBuilder *builder,
    const MbimSmsCdmaReadRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_sms_cdma_read_record_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_sms_cdma_read_record_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_sms_cdma_read_record_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimSmsCdmaReadRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_sms_cdma_read_record_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimSmsPduSendRecord */

static void
_mbim_sms_pdu_send_record_free (MbimSmsPduSendRecord *var)
{
    if (!var)
        return;

    g_free (var->pdu_data);
    g_free (var);
}

/**
 * mbim_sms_pdu_send_record_free:
 * @var: a #MbimSmsPduSendRecord.
 *
 * Frees the memory allocated for the #MbimSmsPduSendRecord.
 */
void
mbim_sms_pdu_send_record_free (MbimSmsPduSendRecord *var)
{
    _mbim_sms_pdu_send_record_free (var);
}

static MbimSmsPduSendRecord *
_mbim_message_read_mbim_sms_pdu_send_record_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimSmsPduSendRecord *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimSmsPduSendRecord, 1);

    {
        const guint8 *tmp;

        tmp = _mbim_message_read_byte_array (self, relative_offset, offset, TRUE, TRUE, &(out->pdu_data_size));
        out->pdu_data = g_malloc (out->pdu_data_size);
        memcpy (out->pdu_data, tmp, out->pdu_data_size);
        offset += 8;
    }

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimSmsPduSendRecord **
_mbim_message_read_mbim_sms_pdu_send_record_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimSmsPduSendRecord **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimSmsPduSendRecord *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_sms_pdu_send_record_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_sms_pdu_send_record_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_sms_pdu_send_record_struct (
    const MbimSmsPduSendRecord *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  PduData = ", line_prefix);
    {
        guint i;
        guint array_size;

        array_size = self->pdu_data_size;
        g_string_append (str, "'");
        for (i = 0; i < array_size; i++)
            g_string_append_printf (str, "%02x%s", self->pdu_data[i], (i == (array_size - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_sms_pdu_send_record_struct_new (const MbimSmsPduSendRecord *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_byte_array (builder, TRUE, TRUE, TRUE, value->pdu_data, value->pdu_data_size);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_sms_pdu_send_record_struct (
    MbimStructBuilder *builder,
    const MbimSmsPduSendRecord *value)
{
    GByteArray *raw;

    raw = _mbim_sms_pdu_send_record_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_sms_pdu_send_record_struct (
    MbimMessageCommandBuilder *builder,
    const MbimSmsPduSendRecord *value)
{
    _mbim_struct_builder_append_mbim_sms_pdu_send_record_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_sms_pdu_send_record_struct_array (
    MbimStructBuilder *builder,
    const MbimSmsPduSendRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_sms_pdu_send_record_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_sms_pdu_send_record_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_sms_pdu_send_record_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimSmsPduSendRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_sms_pdu_send_record_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimSmsCdmaSendRecord */

static void
_mbim_sms_cdma_send_record_free (MbimSmsCdmaSendRecord *var)
{
    if (!var)
        return;

    g_free (var->address);
    g_free (var->encoded_message);
    g_free (var);
}

/**
 * mbim_sms_cdma_send_record_free:
 * @var: a #MbimSmsCdmaSendRecord.
 *
 * Frees the memory allocated for the #MbimSmsCdmaSendRecord.
 */
void
mbim_sms_cdma_send_record_free (MbimSmsCdmaSendRecord *var)
{
    _mbim_sms_cdma_send_record_free (var);
}

static MbimSmsCdmaSendRecord *
_mbim_message_read_mbim_sms_cdma_send_record_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimSmsCdmaSendRecord *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimSmsCdmaSendRecord, 1);

    out->encoding = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->language = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->address = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    {
        const guint8 *tmp;

        tmp = _mbim_message_read_byte_array (self, relative_offset, offset, TRUE, TRUE, &(out->encoded_message_size));
        out->encoded_message = g_malloc (out->encoded_message_size);
        memcpy (out->encoded_message, tmp, out->encoded_message_size);
        offset += 8;
    }

    out->encoded_message_size_in_characters = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimSmsCdmaSendRecord **
_mbim_message_read_mbim_sms_cdma_send_record_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimSmsCdmaSendRecord **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimSmsCdmaSendRecord *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_sms_cdma_send_record_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_sms_cdma_send_record_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_sms_cdma_send_record_struct (
    const MbimSmsCdmaSendRecord *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Encoding = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->encoding);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Language = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->language);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Address = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->address);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  EncodedMessage = ", line_prefix);
    {
        guint i;
        guint array_size;

        array_size = self->encoded_message_size;
        g_string_append (str, "'");
        for (i = 0; i < array_size; i++)
            g_string_append_printf (str, "%02x%s", self->encoded_message[i], (i == (array_size - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  EncodedMessageSizeInCharacters = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->encoded_message_size_in_characters);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_sms_cdma_send_record_struct_new (const MbimSmsCdmaSendRecord *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->encoding);
    _mbim_struct_builder_append_guint32 (builder, value->language);
    _mbim_struct_builder_append_string (builder, value->address);
    _mbim_struct_builder_append_byte_array (builder, TRUE, TRUE, TRUE, value->encoded_message, value->encoded_message_size);
    _mbim_struct_builder_append_guint32 (builder, value->encoded_message_size_in_characters);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_sms_cdma_send_record_struct (
    MbimStructBuilder *builder,
    const MbimSmsCdmaSendRecord *value)
{
    GByteArray *raw;

    raw = _mbim_sms_cdma_send_record_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_sms_cdma_send_record_struct (
    MbimMessageCommandBuilder *builder,
    const MbimSmsCdmaSendRecord *value)
{
    _mbim_struct_builder_append_mbim_sms_cdma_send_record_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_sms_cdma_send_record_struct_array (
    MbimStructBuilder *builder,
    const MbimSmsCdmaSendRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_sms_cdma_send_record_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_sms_cdma_send_record_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_sms_cdma_send_record_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimSmsCdmaSendRecord *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_sms_cdma_send_record_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Message (Query): MBIM Message SMS Configuration */

/**
 * mbim_message_sms_configuration_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Configuration' query command in the 'SMS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_sms_configuration_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_SMS,
                                                 MBIM_CID_SMS_CONFIGURATION,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_sms_configuration_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message SMS Configuration */

/**
 * mbim_message_sms_configuration_set_new:
 * @format: the 'Format' field, given as a #MbimSmsFormat.
 * @sc_address: the 'ScAddress' field, given as a string.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Configuration' set command in the 'SMS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_sms_configuration_set_new (
    MbimSmsFormat format,
    const gchar *sc_address,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_SMS,
                                                 MBIM_CID_SMS_CONFIGURATION,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, format);
    }
    {
        _mbim_message_command_builder_append_string (builder, sc_address);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_sms_configuration_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Format = ", line_prefix);
    {
        MbimSmsFormat tmp;

        tmp = (MbimSmsFormat) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_FORMAT_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_format_get_string (tmp));
#elif defined __MBIM_SMS_FORMAT_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_format_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ScAddress = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message SMS Configuration */

/**
 * mbim_message_sms_configuration_response_parse:
 * @message: the #MbimMessage.
 * @sms_storage_state: return location for a #MbimSmsStorageState, or %NULL if the 'SmsStorageState' field is not needed.
 * @format: return location for a #MbimSmsFormat, or %NULL if the 'Format' field is not needed.
 * @max_messages: return location for a #guint32, or %NULL if the 'MaxMessages' field is not needed.
 * @cdma_short_message_size: return location for a #guint32, or %NULL if the 'CdmaShortMessageSize' field is not needed.
 * @sc_address: return location for a newly allocated string, or %NULL if the 'ScAddress' field is not needed. Free the returned value with g_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Configuration' response command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_configuration_response_parse (
    const MbimMessage *message,
    MbimSmsStorageState *sms_storage_state,
    MbimSmsFormat *format,
    guint32 *max_messages,
    guint32 *cdma_short_message_size,
    gchar **sc_address,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'SmsStorageState' variable */
    {
        if (sms_storage_state != NULL)
            *sms_storage_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Format' variable */
    {
        if (format != NULL)
            *format =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MaxMessages' variable */
    {
        if (max_messages != NULL)
            *max_messages =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CdmaShortMessageSize' variable */
    {
        if (cdma_short_message_size != NULL)
            *cdma_short_message_size =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ScAddress' variable */
    {
        if (sc_address != NULL)
            *sc_address = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    return TRUE;
}

static gchar *
mbim_message_sms_configuration_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SmsStorageState = ", line_prefix);
    {
        MbimSmsStorageState tmp;

        tmp = (MbimSmsStorageState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_STORAGE_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_storage_state_get_string (tmp));
#elif defined __MBIM_SMS_STORAGE_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_storage_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Format = ", line_prefix);
    {
        MbimSmsFormat tmp;

        tmp = (MbimSmsFormat) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_FORMAT_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_format_get_string (tmp));
#elif defined __MBIM_SMS_FORMAT_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_format_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MaxMessages = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CdmaShortMessageSize = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ScAddress = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message SMS Read */

/**
 * mbim_message_sms_read_query_new:
 * @format: the 'Format' field, given as a #MbimSmsFormat.
 * @flag: the 'Flag' field, given as a #MbimSmsFlag.
 * @message_index: the 'MessageIndex' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Read' query command in the 'SMS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_sms_read_query_new (
    MbimSmsFormat format,
    MbimSmsFlag flag,
    guint32 message_index,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_SMS,
                                                 MBIM_CID_SMS_READ,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);
    {
        _mbim_message_command_builder_append_guint32 (builder, format);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, flag);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, message_index);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_sms_read_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Format = ", line_prefix);
    {
        MbimSmsFormat tmp;

        tmp = (MbimSmsFormat) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_FORMAT_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_format_get_string (tmp));
#elif defined __MBIM_SMS_FORMAT_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_format_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Flag = ", line_prefix);
    {
        MbimSmsFlag tmp;

        tmp = (MbimSmsFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_flag_get_string (tmp));
#elif defined __MBIM_SMS_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MessageIndex = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message SMS Read */

/**
 * mbim_message_sms_read_response_parse:
 * @message: the #MbimMessage.
 * @format: return location for a #MbimSmsFormat, or %NULL if the 'Format' field is not needed.
 * @messages_count: return location for a #guint32, or %NULL if the 'MessagesCount' field is not needed.
 * @pdu_messages: return location for a newly allocated array of #MbimSmsPduReadRecords, or %NULL if the 'PduMessages' field is not needed. Free the returned value with mbim_sms_pdu_read_record_array_free().
 * @cdma_messages: return location for a newly allocated array of #MbimSmsCdmaReadRecords, or %NULL if the 'CdmaMessages' field is not needed. Free the returned value with mbim_sms_cdma_read_record_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Read' response command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_read_response_parse (
    const MbimMessage *message,
    MbimSmsFormat *format,
    guint32 *messages_count,
    MbimSmsPduReadRecord ***pdu_messages,
    MbimSmsCdmaReadRecord ***cdma_messages,
    GError **error)
{
    guint32 offset = 0;
    guint32 _format;
    guint32 _messages_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Format' variable */
    {
        _format = _mbim_message_read_guint32 (message, offset);
        if (format != NULL)
            *format = _format;
        offset += 4;
    }

    /* Read the 'MessagesCount' variable */
    {
        _messages_count = _mbim_message_read_guint32 (message, offset);
        if (messages_count != NULL)
            *messages_count = _messages_count;
        offset += 4;
    }

    /* Read the 'PduMessages' variable */
    if (!(_format == MBIM_SMS_FORMAT_PDU)) {
        if (pdu_messages != NULL)
            *pdu_messages = NULL;
    } else {
        if (pdu_messages != NULL)
            *pdu_messages = _mbim_message_read_mbim_sms_pdu_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
    }

    /* Read the 'CdmaMessages' variable */
    if (!(_format == MBIM_SMS_FORMAT_CDMA)) {
        if (cdma_messages != NULL)
            *cdma_messages = NULL;
    } else {
        if (cdma_messages != NULL)
            *cdma_messages = _mbim_message_read_mbim_sms_cdma_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
    }

    return TRUE;
}

static gchar *
mbim_message_sms_read_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _format;
    guint32 _messages_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Format = ", line_prefix);
    {
        _format = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _format);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MessagesCount = ", line_prefix);
    {
        _messages_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _messages_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PduMessages = ", line_prefix);
    if (_format == MBIM_SMS_FORMAT_PDU) {
        MbimSmsPduReadRecord **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_sms_pdu_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _messages_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_sms_pdu_read_record_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_sms_pdu_read_record_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CdmaMessages = ", line_prefix);
    if (_format == MBIM_SMS_FORMAT_CDMA) {
        MbimSmsCdmaReadRecord **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_sms_cdma_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _messages_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_sms_cdma_read_record_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_sms_cdma_read_record_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message SMS Read */

/**
 * mbim_message_sms_read_notification_parse:
 * @message: the #MbimMessage.
 * @format: return location for a #MbimSmsFormat, or %NULL if the 'Format' field is not needed.
 * @messages_count: return location for a #guint32, or %NULL if the 'MessagesCount' field is not needed.
 * @pdu_messages: return location for a newly allocated array of #MbimSmsPduReadRecords, or %NULL if the 'PduMessages' field is not needed. Free the returned value with mbim_sms_pdu_read_record_array_free().
 * @cdma_messages: return location for a newly allocated array of #MbimSmsCdmaReadRecords, or %NULL if the 'CdmaMessages' field is not needed. Free the returned value with mbim_sms_cdma_read_record_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Read' notification command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_read_notification_parse (
    const MbimMessage *message,
    MbimSmsFormat *format,
    guint32 *messages_count,
    MbimSmsPduReadRecord ***pdu_messages,
    MbimSmsCdmaReadRecord ***cdma_messages,
    GError **error)
{
    guint32 offset = 0;
    guint32 _format;
    guint32 _messages_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'Format' variable */
    {
        _format = _mbim_message_read_guint32 (message, offset);
        if (format != NULL)
            *format = _format;
        offset += 4;
    }

    /* Read the 'MessagesCount' variable */
    {
        _messages_count = _mbim_message_read_guint32 (message, offset);
        if (messages_count != NULL)
            *messages_count = _messages_count;
        offset += 4;
    }

    /* Read the 'PduMessages' variable */
    if (!(_format == MBIM_SMS_FORMAT_PDU)) {
        if (pdu_messages != NULL)
            *pdu_messages = NULL;
    } else {
        if (pdu_messages != NULL)
            *pdu_messages = _mbim_message_read_mbim_sms_pdu_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
    }

    /* Read the 'CdmaMessages' variable */
    if (!(_format == MBIM_SMS_FORMAT_CDMA)) {
        if (cdma_messages != NULL)
            *cdma_messages = NULL;
    } else {
        if (cdma_messages != NULL)
            *cdma_messages = _mbim_message_read_mbim_sms_cdma_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
    }

    return TRUE;
}

static gchar *
mbim_message_sms_read_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _format;
    guint32 _messages_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Format = ", line_prefix);
    {
        _format = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _format);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MessagesCount = ", line_prefix);
    {
        _messages_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _messages_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PduMessages = ", line_prefix);
    if (_format == MBIM_SMS_FORMAT_PDU) {
        MbimSmsPduReadRecord **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_sms_pdu_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _messages_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_sms_pdu_read_record_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_sms_pdu_read_record_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CdmaMessages = ", line_prefix);
    if (_format == MBIM_SMS_FORMAT_CDMA) {
        MbimSmsCdmaReadRecord **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_sms_cdma_read_record_struct_array (message, _messages_count, offset, TRUE);
        offset += (8 * _messages_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _messages_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_sms_cdma_read_record_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_sms_cdma_read_record_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message SMS Send */

/**
 * mbim_message_sms_send_set_new:
 * @format: the 'Format' field, given as a #MbimSmsFormat.
 * @pdu_message: the 'PduMessage' field, given as a #MbimSmsPduSendRecord.
 * @cdma_message: the 'CdmaMessage' field, given as a #MbimSmsCdmaSendRecord.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Send' set command in the 'SMS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_sms_send_set_new (
    MbimSmsFormat format,
    const MbimSmsPduSendRecord *pdu_message,
    const MbimSmsCdmaSendRecord *cdma_message,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_SMS,
                                                 MBIM_CID_SMS_SEND,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, format);
    }
    if (format == MBIM_SMS_FORMAT_PDU) {
        _mbim_message_command_builder_append_mbim_sms_pdu_send_record_struct (builder, pdu_message);
    }
    if (format == MBIM_SMS_FORMAT_CDMA) {
        _mbim_message_command_builder_append_mbim_sms_cdma_send_record_struct (builder, cdma_message);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_sms_send_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _format;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Format = ", line_prefix);
    {
        _format = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _format);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PduMessage = ", line_prefix);
    if (_format == MBIM_SMS_FORMAT_PDU) {
        MbimSmsPduSendRecord *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_sms_pdu_send_record_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_sms_pdu_send_record_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_sms_pdu_send_record_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CdmaMessage = ", line_prefix);
    if (_format == MBIM_SMS_FORMAT_CDMA) {
        MbimSmsCdmaSendRecord *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_sms_cdma_send_record_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_sms_cdma_send_record_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_sms_cdma_send_record_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message SMS Send */

/**
 * mbim_message_sms_send_response_parse:
 * @message: the #MbimMessage.
 * @message_reference: return location for a #guint32, or %NULL if the 'MessageReference' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Send' response command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_send_response_parse (
    const MbimMessage *message,
    guint32 *message_reference,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'MessageReference' variable */
    {
        if (message_reference != NULL)
            *message_reference =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_sms_send_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  MessageReference = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message SMS Delete */

/**
 * mbim_message_sms_delete_set_new:
 * @flag: the 'Flag' field, given as a #MbimSmsFlag.
 * @message_index: the 'MessageIndex' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Delete' set command in the 'SMS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_sms_delete_set_new (
    MbimSmsFlag flag,
    guint32 message_index,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_SMS,
                                                 MBIM_CID_SMS_DELETE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, flag);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, message_index);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_sms_delete_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Flag = ", line_prefix);
    {
        MbimSmsFlag tmp;

        tmp = (MbimSmsFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_flag_get_string (tmp));
#elif defined __MBIM_SMS_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MessageIndex = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message SMS Delete */

/**
 * mbim_message_sms_delete_response_parse:
 * @message: the #MbimMessage.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Delete' response command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_delete_response_parse (
    const MbimMessage *message,
    GError **error)
{

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    return TRUE;
}

static gchar *
mbim_message_sms_delete_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message SMS Message Store Status */

/**
 * mbim_message_sms_message_store_status_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Message Store Status' query command in the 'SMS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_sms_message_store_status_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_SMS,
                                                 MBIM_CID_SMS_MESSAGE_STORE_STATUS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_sms_message_store_status_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message SMS Message Store Status */

/**
 * mbim_message_sms_message_store_status_response_parse:
 * @message: the #MbimMessage.
 * @flag: return location for a #MbimSmsStatusFlag, or %NULL if the 'Flag' field is not needed.
 * @message_index: return location for a #guint32, or %NULL if the 'MessageIndex' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Message Store Status' response command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_message_store_status_response_parse (
    const MbimMessage *message,
    MbimSmsStatusFlag *flag,
    guint32 *message_index,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Flag' variable */
    {
        if (flag != NULL)
            *flag =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MessageIndex' variable */
    {
        if (message_index != NULL)
            *message_index =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_sms_message_store_status_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Flag = ", line_prefix);
    {
        MbimSmsStatusFlag tmp;

        tmp = (MbimSmsStatusFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_STATUS_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_status_flag_get_string (tmp));
#elif defined __MBIM_SMS_STATUS_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_status_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MessageIndex = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message SMS Message Store Status */

/**
 * mbim_message_sms_message_store_status_notification_parse:
 * @message: the #MbimMessage.
 * @flag: return location for a #MbimSmsStatusFlag, or %NULL if the 'Flag' field is not needed.
 * @message_index: return location for a #guint32, or %NULL if the 'MessageIndex' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Message Store Status' notification command in the 'SMS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_sms_message_store_status_notification_parse (
    const MbimMessage *message,
    MbimSmsStatusFlag *flag,
    guint32 *message_index,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'Flag' variable */
    {
        if (flag != NULL)
            *flag =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MessageIndex' variable */
    {
        if (message_index != NULL)
            *message_index =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_sms_message_store_status_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Flag = ", line_prefix);
    {
        MbimSmsStatusFlag tmp;

        tmp = (MbimSmsStatusFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_STATUS_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_status_flag_get_string (tmp));
#elif defined __MBIM_SMS_STATUS_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_status_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MessageIndex = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

typedef struct {
  gchar * (* query_cb)        (const MbimMessage *message, const gchar *line_prefix, GError **error);
  gchar * (* set_cb)          (const MbimMessage *message, const gchar *line_prefix, GError **error);
  gchar * (* response_cb)     (const MbimMessage *message, const gchar *line_prefix, GError **error);
  gchar * (* notification_cb) (const MbimMessage *message, const gchar *line_prefix, GError **error);
} GetPrintableCallbacks;

static const GetPrintableCallbacks get_printable_callbacks[] = {
    [MBIM_CID_SMS_CONFIGURATION] = {
        .query_cb = mbim_message_sms_configuration_query_get_printable,
        .set_cb = mbim_message_sms_configuration_set_get_printable,
        .response_cb = mbim_message_sms_configuration_response_get_printable,
    },
    [MBIM_CID_SMS_READ] = {
        .query_cb = mbim_message_sms_read_query_get_printable,
        .response_cb = mbim_message_sms_read_response_get_printable,
        .notification_cb = mbim_message_sms_read_notification_get_printable,
    },
    [MBIM_CID_SMS_SEND] = {
        .set_cb = mbim_message_sms_send_set_get_printable,
        .response_cb = mbim_message_sms_send_response_get_printable,
    },
    [MBIM_CID_SMS_DELETE] = {
        .set_cb = mbim_message_sms_delete_set_get_printable,
        .response_cb = mbim_message_sms_delete_response_get_printable,
    },
    [MBIM_CID_SMS_MESSAGE_STORE_STATUS] = {
        .query_cb = mbim_message_sms_message_store_status_query_get_printable,
        .response_cb = mbim_message_sms_message_store_status_response_get_printable,
        .notification_cb = mbim_message_sms_message_store_status_notification_get_printable,
    },
};

gchar *
__mbim_message_sms_get_printable_fields (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    guint32 cid;

    switch (mbim_message_get_message_type (message)) {
        case MBIM_MESSAGE_TYPE_COMMAND: {
            cid = mbim_message_command_get_cid (message);
            if (cid < G_N_ELEMENTS (get_printable_callbacks)) {
                switch (mbim_message_command_get_command_type (message)) {
                    case MBIM_MESSAGE_COMMAND_TYPE_QUERY:
                        if (get_printable_callbacks[cid].query_cb)
                            return get_printable_callbacks[cid].query_cb (message, line_prefix, error);
                        break;
                    case MBIM_MESSAGE_COMMAND_TYPE_SET:
                        if (get_printable_callbacks[cid].set_cb)
                            return get_printable_callbacks[cid].set_cb (message, line_prefix, error);
                        break;
                    default:
                        g_set_error (error,
                                     MBIM_CORE_ERROR,
                                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                                     "Invalid command type");
                        return NULL;
                }
            }
            break;
        }

        case MBIM_MESSAGE_TYPE_COMMAND_DONE:
            cid = mbim_message_command_done_get_cid (message);
            if (cid < G_N_ELEMENTS (get_printable_callbacks)) {
                if (get_printable_callbacks[cid].response_cb)
                    return get_printable_callbacks[cid].response_cb (message, line_prefix, error);
            }
            break;

        case MBIM_MESSAGE_TYPE_INDICATE_STATUS:
            cid = mbim_message_indicate_status_get_cid (message);
            if (cid < G_N_ELEMENTS (get_printable_callbacks)) {
                if (get_printable_callbacks[cid].notification_cb)
                    return get_printable_callbacks[cid].notification_cb (message, line_prefix, error);
            }
            break;

        default:
            g_set_error (error,
                         MBIM_CORE_ERROR,
                         MBIM_CORE_ERROR_INVALID_MESSAGE,
                         "No contents expected in this message type");
            return NULL;
    }

    g_set_error (error,
                 MBIM_CORE_ERROR,
                 MBIM_CORE_ERROR_INVALID_MESSAGE,
                 "Unknown contents");
    return NULL;
}
