
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2013 - 2018 Aleksander Morgado <aleksander@aleksander.es>
 */


#include <string.h>

#include "mbim-basic-connect.h"
#include "mbim-message-private.h"
#include "mbim-enum-types.h"
#include "mbim-error-types.h"
#include "mbim-device.h"
#include "mbim-utils.h"

/*****************************************************************************/
/* Struct: MbimPinDesc */

static void
_mbim_pin_desc_free (MbimPinDesc *var)
{
    if (!var)
        return;

    g_free (var);
}

/**
 * mbim_pin_desc_free:
 * @var: a #MbimPinDesc.
 *
 * Frees the memory allocated for the #MbimPinDesc.
 */
void
mbim_pin_desc_free (MbimPinDesc *var)
{
    _mbim_pin_desc_free (var);
}

static MbimPinDesc *
_mbim_message_read_mbim_pin_desc_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimPinDesc *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimPinDesc, 1);

    out->pin_mode = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->pin_format = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->pin_length_min = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->pin_length_max = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimPinDesc **
_mbim_message_read_mbim_pin_desc_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimPinDesc **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimPinDesc *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 16)
            out[i] = _mbim_message_read_mbim_pin_desc_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_pin_desc_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_pin_desc_struct (
    const MbimPinDesc *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  PinMode = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->pin_mode);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  PinFormat = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->pin_format);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  PinLengthMin = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->pin_length_min);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  PinLengthMax = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->pin_length_max);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_pin_desc_struct_new (const MbimPinDesc *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->pin_mode);
    _mbim_struct_builder_append_guint32 (builder, value->pin_format);
    _mbim_struct_builder_append_guint32 (builder, value->pin_length_min);
    _mbim_struct_builder_append_guint32 (builder, value->pin_length_max);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_pin_desc_struct (
    MbimStructBuilder *builder,
    const MbimPinDesc *value)
{
    GByteArray *raw;

    raw = _mbim_pin_desc_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_pin_desc_struct (
    MbimMessageCommandBuilder *builder,
    const MbimPinDesc *value)
{
    _mbim_struct_builder_append_mbim_pin_desc_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_pin_desc_struct_array (
    MbimStructBuilder *builder,
    const MbimPinDesc *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_pin_desc_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_pin_desc_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_pin_desc_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimPinDesc *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_pin_desc_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimProvider */

static void
_mbim_provider_free (MbimProvider *var)
{
    if (!var)
        return;

    g_free (var->provider_id);
    g_free (var->provider_name);
    g_free (var);
}

/**
 * mbim_provider_free:
 * @var: a #MbimProvider.
 *
 * Frees the memory allocated for the #MbimProvider.
 */
void
mbim_provider_free (MbimProvider *var)
{
    _mbim_provider_free (var);
}

/**
 * mbim_provider_array_free:
 * @array: a #NULL terminated array of #MbimProvider structs.
 *
 * Frees the memory allocated for the array of #MbimProviders.
 */
void
mbim_provider_array_free (MbimProvider **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_provider_free (array[i]);
    g_free (array);
}

static MbimProvider *
_mbim_message_read_mbim_provider_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimProvider *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimProvider, 1);

    out->provider_id = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->provider_state = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->provider_name = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->cellular_class = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->rssi = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->error_rate = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimProvider **
_mbim_message_read_mbim_provider_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimProvider **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimProvider *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_provider_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_provider_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_provider_struct (
    const MbimProvider *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProviderId = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->provider_id);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  ProviderState = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->provider_state);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  ProviderName = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->provider_name);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  CellularClass = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->cellular_class);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Rssi = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->rssi);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  ErrorRate = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->error_rate);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_provider_struct_new (const MbimProvider *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_string (builder, value->provider_id);
    _mbim_struct_builder_append_guint32 (builder, value->provider_state);
    _mbim_struct_builder_append_string (builder, value->provider_name);
    _mbim_struct_builder_append_guint32 (builder, value->cellular_class);
    _mbim_struct_builder_append_guint32 (builder, value->rssi);
    _mbim_struct_builder_append_guint32 (builder, value->error_rate);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_provider_struct (
    MbimStructBuilder *builder,
    const MbimProvider *value)
{
    GByteArray *raw;

    raw = _mbim_provider_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_provider_struct (
    MbimMessageCommandBuilder *builder,
    const MbimProvider *value)
{
    _mbim_struct_builder_append_mbim_provider_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_provider_struct_array (
    MbimStructBuilder *builder,
    const MbimProvider *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_provider_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_provider_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_provider_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimProvider *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_provider_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimProvisionedContextElement */

static void
_mbim_provisioned_context_element_free (MbimProvisionedContextElement *var)
{
    if (!var)
        return;

    g_free (var->access_string);
    g_free (var->user_name);
    g_free (var->password);
    g_free (var);
}

/**
 * mbim_provisioned_context_element_array_free:
 * @array: a #NULL terminated array of #MbimProvisionedContextElement structs.
 *
 * Frees the memory allocated for the array of #MbimProvisionedContextElements.
 */
void
mbim_provisioned_context_element_array_free (MbimProvisionedContextElement **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_provisioned_context_element_free (array[i]);
    g_free (array);
}

static MbimProvisionedContextElement *
_mbim_message_read_mbim_provisioned_context_element_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimProvisionedContextElement *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimProvisionedContextElement, 1);

    out->context_id = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    memcpy (&(out->context_type), _mbim_message_read_uuid (self, offset), 16);
    offset += 16;

    out->access_string = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->user_name = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->password = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->compression = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->auth_protocol = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimProvisionedContextElement **
_mbim_message_read_mbim_provisioned_context_element_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimProvisionedContextElement **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimProvisionedContextElement *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_provisioned_context_element_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_provisioned_context_element_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_provisioned_context_element_struct (
    const MbimProvisionedContextElement *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ContextId = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->context_id);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  ContextType = ", line_prefix);
    {
        gchar *tmpstr;

        tmpstr = mbim_uuid_get_printable (&(self->context_type));
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  AccessString = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->access_string);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  UserName = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->user_name);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Password = ", line_prefix);
    {
        g_string_append_printf (str, "'%s'", self->password);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Compression = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->compression);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  AuthProtocol = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->auth_protocol);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_provisioned_context_element_struct_new (const MbimProvisionedContextElement *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->context_id);
    _mbim_struct_builder_append_uuid (builder, &(value->context_type));
    _mbim_struct_builder_append_string (builder, value->access_string);
    _mbim_struct_builder_append_string (builder, value->user_name);
    _mbim_struct_builder_append_string (builder, value->password);
    _mbim_struct_builder_append_guint32 (builder, value->compression);
    _mbim_struct_builder_append_guint32 (builder, value->auth_protocol);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_provisioned_context_element_struct (
    MbimStructBuilder *builder,
    const MbimProvisionedContextElement *value)
{
    GByteArray *raw;

    raw = _mbim_provisioned_context_element_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_provisioned_context_element_struct (
    MbimMessageCommandBuilder *builder,
    const MbimProvisionedContextElement *value)
{
    _mbim_struct_builder_append_mbim_provisioned_context_element_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_provisioned_context_element_struct_array (
    MbimStructBuilder *builder,
    const MbimProvisionedContextElement *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_provisioned_context_element_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_provisioned_context_element_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_provisioned_context_element_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimProvisionedContextElement *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_provisioned_context_element_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimIPv4Element */

static void
_mbim_ipv4_element_free (MbimIPv4Element *var)
{
    if (!var)
        return;

    g_free (var);
}

/**
 * mbim_ipv4_element_array_free:
 * @array: a #NULL terminated array of #MbimIPv4Element structs.
 *
 * Frees the memory allocated for the array of #MbimIPv4Elements.
 */
void
mbim_ipv4_element_array_free (MbimIPv4Element **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_ipv4_element_free (array[i]);
    g_free (array);
}

static MbimIPv4Element *
_mbim_message_read_mbim_ipv4_element_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimIPv4Element *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimIPv4Element, 1);

    out->on_link_prefix_length = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    memcpy (&(out->ipv4_address), _mbim_message_read_ipv4 (self, offset, FALSE), 4);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimIPv4Element **
_mbim_message_read_mbim_ipv4_element_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimIPv4Element **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimIPv4Element *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_ipv4_element_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_ipv4_element_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_ipv4_element_struct (
    const MbimIPv4Element *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  OnLinkPrefixLength = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->on_link_prefix_length);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  IPv4Address = ", line_prefix);
    {
        GInetAddress *addr;
        gchar *tmpstr;

        addr = g_inet_address_new_from_bytes ((guint8 *)&(self->ipv4_address.addr), G_SOCKET_FAMILY_IPV4);
        tmpstr = g_inet_address_to_string (addr);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
        g_object_unref (addr);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_ipv4_element_struct_new (const MbimIPv4Element *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->on_link_prefix_length);
    _mbim_struct_builder_append_ipv4 (builder, &value->ipv4_address, FALSE);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_ipv4_element_struct (
    MbimStructBuilder *builder,
    const MbimIPv4Element *value)
{
    GByteArray *raw;

    raw = _mbim_ipv4_element_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_ipv4_element_struct (
    MbimMessageCommandBuilder *builder,
    const MbimIPv4Element *value)
{
    _mbim_struct_builder_append_mbim_ipv4_element_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_ipv4_element_struct_array (
    MbimStructBuilder *builder,
    const MbimIPv4Element *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_ipv4_element_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_ipv4_element_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_ipv4_element_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimIPv4Element *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_ipv4_element_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimIPv6Element */

static void
_mbim_ipv6_element_free (MbimIPv6Element *var)
{
    if (!var)
        return;

    g_free (var);
}

/**
 * mbim_ipv6_element_array_free:
 * @array: a #NULL terminated array of #MbimIPv6Element structs.
 *
 * Frees the memory allocated for the array of #MbimIPv6Elements.
 */
void
mbim_ipv6_element_array_free (MbimIPv6Element **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_ipv6_element_free (array[i]);
    g_free (array);
}

static MbimIPv6Element *
_mbim_message_read_mbim_ipv6_element_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimIPv6Element *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimIPv6Element, 1);

    out->on_link_prefix_length = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    memcpy (&(out->ipv6_address), _mbim_message_read_ipv6 (self, offset, FALSE), 16);
    offset += 16;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimIPv6Element **
_mbim_message_read_mbim_ipv6_element_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimIPv6Element **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimIPv6Element *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 20)
            out[i] = _mbim_message_read_mbim_ipv6_element_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_ipv6_element_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_ipv6_element_struct (
    const MbimIPv6Element *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  OnLinkPrefixLength = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->on_link_prefix_length);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  IPv6Address = ", line_prefix);
    {
        GInetAddress *addr;
        gchar *tmpstr;

        addr = g_inet_address_new_from_bytes ((guint8 *)&(self->ipv6_address.addr), G_SOCKET_FAMILY_IPV6);
        tmpstr = g_inet_address_to_string (addr);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
        g_object_unref (addr);
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_ipv6_element_struct_new (const MbimIPv6Element *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->on_link_prefix_length);
    _mbim_struct_builder_append_ipv6 (builder, &value->ipv6_address, FALSE);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_ipv6_element_struct (
    MbimStructBuilder *builder,
    const MbimIPv6Element *value)
{
    GByteArray *raw;

    raw = _mbim_ipv6_element_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_ipv6_element_struct (
    MbimMessageCommandBuilder *builder,
    const MbimIPv6Element *value)
{
    _mbim_struct_builder_append_mbim_ipv6_element_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_ipv6_element_struct_array (
    MbimStructBuilder *builder,
    const MbimIPv6Element *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_ipv6_element_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_ipv6_element_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_ipv6_element_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimIPv6Element *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_ipv6_element_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimDeviceServiceElement */

static void
_mbim_device_service_element_free (MbimDeviceServiceElement *var)
{
    if (!var)
        return;

    g_free (var->cids);
    g_free (var);
}

/**
 * mbim_device_service_element_array_free:
 * @array: a #NULL terminated array of #MbimDeviceServiceElement structs.
 *
 * Frees the memory allocated for the array of #MbimDeviceServiceElements.
 */
void
mbim_device_service_element_array_free (MbimDeviceServiceElement **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_device_service_element_free (array[i]);
    g_free (array);
}

static MbimDeviceServiceElement *
_mbim_message_read_mbim_device_service_element_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimDeviceServiceElement *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimDeviceServiceElement, 1);

    memcpy (&(out->device_service_id), _mbim_message_read_uuid (self, offset), 16);
    offset += 16;

    out->dss_payload = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->max_dss_instances = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->cids_count = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->cids = _mbim_message_read_guint32_array (self, out->cids_count, offset);
    offset += (4 * out->cids_count);

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimDeviceServiceElement **
_mbim_message_read_mbim_device_service_element_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimDeviceServiceElement **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimDeviceServiceElement *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_device_service_element_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_device_service_element_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_device_service_element_struct (
    const MbimDeviceServiceElement *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  DeviceServiceId = ", line_prefix);
    {
        gchar *tmpstr;

        tmpstr = mbim_uuid_get_printable (&(self->device_service_id));
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  DssPayload = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->dss_payload);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  MaxDssInstances = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->max_dss_instances);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  CidsCount = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->cids_count);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Cids = ", line_prefix);
    {
        guint i;

        g_string_append (str, "'");
        for (i = 0; i < self->cids_count; i++)
            g_string_append_printf (str, "%" G_GUINT32_FORMAT "%s", self->cids[i], (i == (self->cids_count - 1)) ? "" : "," );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_device_service_element_struct_new (const MbimDeviceServiceElement *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_uuid (builder, &(value->device_service_id));
    _mbim_struct_builder_append_guint32 (builder, value->dss_payload);
    _mbim_struct_builder_append_guint32 (builder, value->max_dss_instances);
    _mbim_struct_builder_append_guint32 (builder, value->cids_count);
    _mbim_struct_builder_append_guint32_array (builder, value->cids, value->cids_count);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_device_service_element_struct (
    MbimStructBuilder *builder,
    const MbimDeviceServiceElement *value)
{
    GByteArray *raw;

    raw = _mbim_device_service_element_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_device_service_element_struct (
    MbimMessageCommandBuilder *builder,
    const MbimDeviceServiceElement *value)
{
    _mbim_struct_builder_append_mbim_device_service_element_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_device_service_element_struct_array (
    MbimStructBuilder *builder,
    const MbimDeviceServiceElement *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_device_service_element_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_device_service_element_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_device_service_element_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimDeviceServiceElement *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_device_service_element_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimEventEntry */

static void
_mbim_event_entry_free (MbimEventEntry *var)
{
    if (!var)
        return;

    g_free (var->cids);
    g_free (var);
}

/**
 * mbim_event_entry_array_free:
 * @array: a #NULL terminated array of #MbimEventEntry structs.
 *
 * Frees the memory allocated for the array of #MbimEventEntrys.
 */
void
mbim_event_entry_array_free (MbimEventEntry **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_event_entry_free (array[i]);
    g_free (array);
}

static MbimEventEntry *
_mbim_message_read_mbim_event_entry_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimEventEntry *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimEventEntry, 1);

    memcpy (&(out->device_service_id), _mbim_message_read_uuid (self, offset), 16);
    offset += 16;

    out->cids_count = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->cids = _mbim_message_read_guint32_array (self, out->cids_count, offset);
    offset += (4 * out->cids_count);

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimEventEntry **
_mbim_message_read_mbim_event_entry_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimEventEntry **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimEventEntry *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_event_entry_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_event_entry_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_event_entry_struct (
    const MbimEventEntry *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  DeviceServiceId = ", line_prefix);
    {
        gchar *tmpstr;

        tmpstr = mbim_uuid_get_printable (&(self->device_service_id));
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  CidsCount = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->cids_count);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  Cids = ", line_prefix);
    {
        guint i;

        g_string_append (str, "'");
        for (i = 0; i < self->cids_count; i++)
            g_string_append_printf (str, "%" G_GUINT32_FORMAT "%s", self->cids[i], (i == (self->cids_count - 1)) ? "" : "," );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_event_entry_struct_new (const MbimEventEntry *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_uuid (builder, &(value->device_service_id));
    _mbim_struct_builder_append_guint32 (builder, value->cids_count);
    _mbim_struct_builder_append_guint32_array (builder, value->cids, value->cids_count);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_event_entry_struct (
    MbimStructBuilder *builder,
    const MbimEventEntry *value)
{
    GByteArray *raw;

    raw = _mbim_event_entry_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_event_entry_struct (
    MbimMessageCommandBuilder *builder,
    const MbimEventEntry *value)
{
    _mbim_struct_builder_append_mbim_event_entry_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_event_entry_struct_array (
    MbimStructBuilder *builder,
    const MbimEventEntry *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_event_entry_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_event_entry_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_event_entry_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimEventEntry *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_event_entry_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Struct: MbimPacketFilter */

static void
_mbim_packet_filter_free (MbimPacketFilter *var)
{
    if (!var)
        return;

    g_free (var->packet_filter);
    g_free (var->packet_mask);
    g_free (var);
}

/**
 * mbim_packet_filter_array_free:
 * @array: a #NULL terminated array of #MbimPacketFilter structs.
 *
 * Frees the memory allocated for the array of #MbimPacketFilters.
 */
void
mbim_packet_filter_array_free (MbimPacketFilter **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_packet_filter_free (array[i]);
    g_free (array);
}

static MbimPacketFilter *
_mbim_message_read_mbim_packet_filter_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimPacketFilter *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimPacketFilter, 1);

    out->filter_size = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    {
        const guint8 *tmp;

        tmp = _mbim_message_read_byte_array (self, relative_offset, offset, TRUE, FALSE, NULL);
        out->packet_filter = g_malloc (out->filter_size);
        memcpy (out->packet_filter, tmp, out->filter_size);
        offset += 4;
    }

    {
        const guint8 *tmp;

        tmp = _mbim_message_read_byte_array (self, relative_offset, offset, TRUE, FALSE, NULL);
        out->packet_mask = g_malloc (out->filter_size);
        memcpy (out->packet_mask, tmp, out->filter_size);
        offset += 4;
    }

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimPacketFilter **
_mbim_message_read_mbim_packet_filter_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimPacketFilter **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimPacketFilter *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_packet_filter_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_packet_filter_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static gchar *
_mbim_message_print_mbim_packet_filter_struct (
    const MbimPacketFilter *self,
    const gchar *line_prefix)
{
    GString *str;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  FilterSize = ", line_prefix);
    {
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", self->filter_size);
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  PacketFilter = ", line_prefix);
    {
        guint i;
        guint array_size;

        array_size = self->filter_size;
        g_string_append (str, "'");
        for (i = 0; i < array_size; i++)
            g_string_append_printf (str, "%02x%s", self->packet_filter[i], (i == (array_size - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    g_string_append_printf (str, "%s  PacketMask = ", line_prefix);
    {
        guint i;
        guint array_size;

        array_size = self->filter_size;
        g_string_append (str, "'");
        for (i = 0; i < array_size; i++)
            g_string_append_printf (str, "%02x%s", self->packet_mask[i], (i == (array_size - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");
    return g_string_free (str, FALSE);
}

static GByteArray *
_mbim_packet_filter_struct_new (const MbimPacketFilter *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->filter_size);
    _mbim_struct_builder_append_byte_array (builder, TRUE, FALSE, TRUE, value->packet_filter, value->filter_size);
    _mbim_struct_builder_append_byte_array (builder, TRUE, FALSE, TRUE, value->packet_mask, value->filter_size);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_packet_filter_struct (
    MbimStructBuilder *builder,
    const MbimPacketFilter *value)
{
    GByteArray *raw;

    raw = _mbim_packet_filter_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_packet_filter_struct (
    MbimMessageCommandBuilder *builder,
    const MbimPacketFilter *value)
{
    _mbim_struct_builder_append_mbim_packet_filter_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_packet_filter_struct_array (
    MbimStructBuilder *builder,
    const MbimPacketFilter *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_packet_filter_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_packet_filter_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_packet_filter_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimPacketFilter *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_packet_filter_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Device Caps */

/**
 * mbim_message_device_caps_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Device Caps' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_device_caps_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_DEVICE_CAPS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_device_caps_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Device Caps */

/**
 * mbim_message_device_caps_response_parse:
 * @message: the #MbimMessage.
 * @device_type: return location for a #MbimDeviceType, or %NULL if the 'DeviceType' field is not needed.
 * @cellular_class: return location for a #MbimCellularClass, or %NULL if the 'CellularClass' field is not needed.
 * @voice_class: return location for a #MbimVoiceClass, or %NULL if the 'VoiceClass' field is not needed.
 * @sim_class: return location for a #MbimSimClass, or %NULL if the 'SimClass' field is not needed.
 * @data_class: return location for a #MbimDataClass, or %NULL if the 'DataClass' field is not needed.
 * @sms_caps: return location for a #MbimSmsCaps, or %NULL if the 'SmsCaps' field is not needed.
 * @control_caps: return location for a #MbimCtrlCaps, or %NULL if the 'ControlCaps' field is not needed.
 * @max_sessions: return location for a #guint32, or %NULL if the 'MaxSessions' field is not needed.
 * @custom_data_class: return location for a newly allocated string, or %NULL if the 'CustomDataClass' field is not needed. Free the returned value with g_free().
 * @device_id: return location for a newly allocated string, or %NULL if the 'DeviceId' field is not needed. Free the returned value with g_free().
 * @firmware_info: return location for a newly allocated string, or %NULL if the 'FirmwareInfo' field is not needed. Free the returned value with g_free().
 * @hardware_info: return location for a newly allocated string, or %NULL if the 'HardwareInfo' field is not needed. Free the returned value with g_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Device Caps' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_device_caps_response_parse (
    const MbimMessage *message,
    MbimDeviceType *device_type,
    MbimCellularClass *cellular_class,
    MbimVoiceClass *voice_class,
    MbimSimClass *sim_class,
    MbimDataClass *data_class,
    MbimSmsCaps *sms_caps,
    MbimCtrlCaps *control_caps,
    guint32 *max_sessions,
    gchar **custom_data_class,
    gchar **device_id,
    gchar **firmware_info,
    gchar **hardware_info,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'DeviceType' variable */
    {
        if (device_type != NULL)
            *device_type =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CellularClass' variable */
    {
        if (cellular_class != NULL)
            *cellular_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'VoiceClass' variable */
    {
        if (voice_class != NULL)
            *voice_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SimClass' variable */
    {
        if (sim_class != NULL)
            *sim_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'DataClass' variable */
    {
        if (data_class != NULL)
            *data_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SmsCaps' variable */
    {
        if (sms_caps != NULL)
            *sms_caps =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ControlCaps' variable */
    {
        if (control_caps != NULL)
            *control_caps =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MaxSessions' variable */
    {
        if (max_sessions != NULL)
            *max_sessions =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CustomDataClass' variable */
    {
        if (custom_data_class != NULL)
            *custom_data_class = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'DeviceId' variable */
    {
        if (device_id != NULL)
            *device_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'FirmwareInfo' variable */
    {
        if (firmware_info != NULL)
            *firmware_info = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'HardwareInfo' variable */
    {
        if (hardware_info != NULL)
            *hardware_info = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    return TRUE;
}

static gchar *
mbim_message_device_caps_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  DeviceType = ", line_prefix);
    {
        MbimDeviceType tmp;

        tmp = (MbimDeviceType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DEVICE_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_device_type_get_string (tmp));
#elif defined __MBIM_DEVICE_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_device_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CellularClass = ", line_prefix);
    {
        MbimCellularClass tmp;

        tmp = (MbimCellularClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CELLULAR_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_cellular_class_get_string (tmp));
#elif defined __MBIM_CELLULAR_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_cellular_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  VoiceClass = ", line_prefix);
    {
        MbimVoiceClass tmp;

        tmp = (MbimVoiceClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_VOICE_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_voice_class_get_string (tmp));
#elif defined __MBIM_VOICE_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_voice_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SimClass = ", line_prefix);
    {
        MbimSimClass tmp;

        tmp = (MbimSimClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SIM_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sim_class_get_string (tmp));
#elif defined __MBIM_SIM_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sim_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  DataClass = ", line_prefix);
    {
        MbimDataClass tmp;

        tmp = (MbimDataClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DATA_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_data_class_get_string (tmp));
#elif defined __MBIM_DATA_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_data_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SmsCaps = ", line_prefix);
    {
        MbimSmsCaps tmp;

        tmp = (MbimSmsCaps) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SMS_CAPS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_sms_caps_get_string (tmp));
#elif defined __MBIM_SMS_CAPS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_sms_caps_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ControlCaps = ", line_prefix);
    {
        MbimCtrlCaps tmp;

        tmp = (MbimCtrlCaps) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CTRL_CAPS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ctrl_caps_get_string (tmp));
#elif defined __MBIM_CTRL_CAPS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ctrl_caps_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MaxSessions = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CustomDataClass = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  DeviceId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  FirmwareInfo = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  HardwareInfo = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Subscriber Ready Status */

/**
 * mbim_message_subscriber_ready_status_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Subscriber Ready Status' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_subscriber_ready_status_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_SUBSCRIBER_READY_STATUS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_subscriber_ready_status_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Subscriber Ready Status */

/**
 * mbim_message_subscriber_ready_status_response_parse:
 * @message: the #MbimMessage.
 * @ready_state: return location for a #MbimSubscriberReadyState, or %NULL if the 'ReadyState' field is not needed.
 * @subscriber_id: return location for a newly allocated string, or %NULL if the 'SubscriberId' field is not needed. Free the returned value with g_free().
 * @sim_icc_id: return location for a newly allocated string, or %NULL if the 'SimIccId' field is not needed. Free the returned value with g_free().
 * @ready_info: return location for a #MbimReadyInfoFlag, or %NULL if the 'ReadyInfo' field is not needed.
 * @telephone_numbers_count: return location for a #guint32, or %NULL if the 'TelephoneNumbersCount' field is not needed.
 * @telephone_numbers: return location for a newly allocated array of strings, or %NULL if the 'TelephoneNumbers' field is not needed. Free the returned value with g_strfreev().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Subscriber Ready Status' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_subscriber_ready_status_response_parse (
    const MbimMessage *message,
    MbimSubscriberReadyState *ready_state,
    gchar **subscriber_id,
    gchar **sim_icc_id,
    MbimReadyInfoFlag *ready_info,
    guint32 *telephone_numbers_count,
    gchar ***telephone_numbers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _telephone_numbers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'ReadyState' variable */
    {
        if (ready_state != NULL)
            *ready_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SubscriberId' variable */
    {
        if (subscriber_id != NULL)
            *subscriber_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'SimIccId' variable */
    {
        if (sim_icc_id != NULL)
            *sim_icc_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'ReadyInfo' variable */
    {
        if (ready_info != NULL)
            *ready_info =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'TelephoneNumbersCount' variable */
    {
        _telephone_numbers_count = _mbim_message_read_guint32 (message, offset);
        if (telephone_numbers_count != NULL)
            *telephone_numbers_count = _telephone_numbers_count;
        offset += 4;
    }

    /* Read the 'TelephoneNumbers' variable */
    {
        if (telephone_numbers != NULL)
            *telephone_numbers = _mbim_message_read_string_array (message, _telephone_numbers_count, 0, offset);
        offset += (8 * _telephone_numbers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_subscriber_ready_status_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _telephone_numbers_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ReadyState = ", line_prefix);
    {
        MbimSubscriberReadyState tmp;

        tmp = (MbimSubscriberReadyState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SUBSCRIBER_READY_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_subscriber_ready_state_get_string (tmp));
#elif defined __MBIM_SUBSCRIBER_READY_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_subscriber_ready_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SubscriberId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SimIccId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ReadyInfo = ", line_prefix);
    {
        MbimReadyInfoFlag tmp;

        tmp = (MbimReadyInfoFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_READY_INFO_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ready_info_flag_get_string (tmp));
#elif defined __MBIM_READY_INFO_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ready_info_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  TelephoneNumbersCount = ", line_prefix);
    {
        _telephone_numbers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _telephone_numbers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  TelephoneNumbers = ", line_prefix);
    {
        gchar **tmp;
        guint i;

        tmp = _mbim_message_read_string_array (message, _telephone_numbers_count, 0, offset);
        offset += (8 * _telephone_numbers_count);

        g_string_append (str, "'");
        for (i = 0; i < _telephone_numbers_count; i++) {
            g_string_append (str, tmp[i]);
            if (i < (_telephone_numbers_count - 1))
                g_string_append (str, ", ");
        }
        g_string_append (str, "'");
        g_strfreev (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Subscriber Ready Status */

/**
 * mbim_message_subscriber_ready_status_notification_parse:
 * @message: the #MbimMessage.
 * @ready_state: return location for a #MbimSubscriberReadyState, or %NULL if the 'ReadyState' field is not needed.
 * @subscriber_id: return location for a newly allocated string, or %NULL if the 'SubscriberId' field is not needed. Free the returned value with g_free().
 * @sim_icc_id: return location for a newly allocated string, or %NULL if the 'SimIccId' field is not needed. Free the returned value with g_free().
 * @ready_info: return location for a #MbimReadyInfoFlag, or %NULL if the 'ReadyInfo' field is not needed.
 * @telephone_numbers_count: return location for a #guint32, or %NULL if the 'TelephoneNumbersCount' field is not needed.
 * @telephone_numbers: return location for a newly allocated array of strings, or %NULL if the 'TelephoneNumbers' field is not needed. Free the returned value with g_strfreev().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Subscriber Ready Status' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_subscriber_ready_status_notification_parse (
    const MbimMessage *message,
    MbimSubscriberReadyState *ready_state,
    gchar **subscriber_id,
    gchar **sim_icc_id,
    MbimReadyInfoFlag *ready_info,
    guint32 *telephone_numbers_count,
    gchar ***telephone_numbers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _telephone_numbers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'ReadyState' variable */
    {
        if (ready_state != NULL)
            *ready_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SubscriberId' variable */
    {
        if (subscriber_id != NULL)
            *subscriber_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'SimIccId' variable */
    {
        if (sim_icc_id != NULL)
            *sim_icc_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'ReadyInfo' variable */
    {
        if (ready_info != NULL)
            *ready_info =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'TelephoneNumbersCount' variable */
    {
        _telephone_numbers_count = _mbim_message_read_guint32 (message, offset);
        if (telephone_numbers_count != NULL)
            *telephone_numbers_count = _telephone_numbers_count;
        offset += 4;
    }

    /* Read the 'TelephoneNumbers' variable */
    {
        if (telephone_numbers != NULL)
            *telephone_numbers = _mbim_message_read_string_array (message, _telephone_numbers_count, 0, offset);
        offset += (8 * _telephone_numbers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_subscriber_ready_status_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _telephone_numbers_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ReadyState = ", line_prefix);
    {
        MbimSubscriberReadyState tmp;

        tmp = (MbimSubscriberReadyState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_SUBSCRIBER_READY_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_subscriber_ready_state_get_string (tmp));
#elif defined __MBIM_SUBSCRIBER_READY_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_subscriber_ready_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SubscriberId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SimIccId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ReadyInfo = ", line_prefix);
    {
        MbimReadyInfoFlag tmp;

        tmp = (MbimReadyInfoFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_READY_INFO_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ready_info_flag_get_string (tmp));
#elif defined __MBIM_READY_INFO_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ready_info_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  TelephoneNumbersCount = ", line_prefix);
    {
        _telephone_numbers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _telephone_numbers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  TelephoneNumbers = ", line_prefix);
    {
        gchar **tmp;
        guint i;

        tmp = _mbim_message_read_string_array (message, _telephone_numbers_count, 0, offset);
        offset += (8 * _telephone_numbers_count);

        g_string_append (str, "'");
        for (i = 0; i < _telephone_numbers_count; i++) {
            g_string_append (str, tmp[i]);
            if (i < (_telephone_numbers_count - 1))
                g_string_append (str, ", ");
        }
        g_string_append (str, "'");
        g_strfreev (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Radio State */

/**
 * mbim_message_radio_state_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Radio State' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_radio_state_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_RADIO_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_radio_state_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Radio State */

/**
 * mbim_message_radio_state_set_new:
 * @radio_state: the 'RadioState' field, given as a #MbimRadioSwitchState.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Radio State' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_radio_state_set_new (
    MbimRadioSwitchState radio_state,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_RADIO_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, radio_state);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_radio_state_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  RadioState = ", line_prefix);
    {
        MbimRadioSwitchState tmp;

        tmp = (MbimRadioSwitchState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_RADIO_SWITCH_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_radio_switch_state_get_string (tmp));
#elif defined __MBIM_RADIO_SWITCH_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_radio_switch_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Radio State */

/**
 * mbim_message_radio_state_response_parse:
 * @message: the #MbimMessage.
 * @hw_radio_state: return location for a #MbimRadioSwitchState, or %NULL if the 'HwRadioState' field is not needed.
 * @sw_radio_state: return location for a #MbimRadioSwitchState, or %NULL if the 'SwRadioState' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Radio State' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_radio_state_response_parse (
    const MbimMessage *message,
    MbimRadioSwitchState *hw_radio_state,
    MbimRadioSwitchState *sw_radio_state,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'HwRadioState' variable */
    {
        if (hw_radio_state != NULL)
            *hw_radio_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SwRadioState' variable */
    {
        if (sw_radio_state != NULL)
            *sw_radio_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_radio_state_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  HwRadioState = ", line_prefix);
    {
        MbimRadioSwitchState tmp;

        tmp = (MbimRadioSwitchState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_RADIO_SWITCH_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_radio_switch_state_get_string (tmp));
#elif defined __MBIM_RADIO_SWITCH_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_radio_switch_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SwRadioState = ", line_prefix);
    {
        MbimRadioSwitchState tmp;

        tmp = (MbimRadioSwitchState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_RADIO_SWITCH_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_radio_switch_state_get_string (tmp));
#elif defined __MBIM_RADIO_SWITCH_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_radio_switch_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Radio State */

/**
 * mbim_message_radio_state_notification_parse:
 * @message: the #MbimMessage.
 * @hw_radio_state: return location for a #MbimRadioSwitchState, or %NULL if the 'HwRadioState' field is not needed.
 * @sw_radio_state: return location for a #MbimRadioSwitchState, or %NULL if the 'SwRadioState' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Radio State' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_radio_state_notification_parse (
    const MbimMessage *message,
    MbimRadioSwitchState *hw_radio_state,
    MbimRadioSwitchState *sw_radio_state,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'HwRadioState' variable */
    {
        if (hw_radio_state != NULL)
            *hw_radio_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SwRadioState' variable */
    {
        if (sw_radio_state != NULL)
            *sw_radio_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_radio_state_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  HwRadioState = ", line_prefix);
    {
        MbimRadioSwitchState tmp;

        tmp = (MbimRadioSwitchState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_RADIO_SWITCH_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_radio_switch_state_get_string (tmp));
#elif defined __MBIM_RADIO_SWITCH_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_radio_switch_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SwRadioState = ", line_prefix);
    {
        MbimRadioSwitchState tmp;

        tmp = (MbimRadioSwitchState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_RADIO_SWITCH_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_radio_switch_state_get_string (tmp));
#elif defined __MBIM_RADIO_SWITCH_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_radio_switch_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Pin */

/**
 * mbim_message_pin_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Pin' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_pin_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PIN,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_pin_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Pin */

/**
 * mbim_message_pin_set_new:
 * @pin_type: the 'PinType' field, given as a #MbimPinType.
 * @pin_operation: the 'PinOperation' field, given as a #MbimPinOperation.
 * @pin: the 'Pin' field, given as a string.
 * @new_pin: the 'NewPin' field, given as a string.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Pin' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_pin_set_new (
    MbimPinType pin_type,
    MbimPinOperation pin_operation,
    const gchar *pin,
    const gchar *new_pin,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PIN,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, pin_type);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, pin_operation);
    }
    {
        _mbim_message_command_builder_append_string (builder, pin);
    }
    {
        _mbim_message_command_builder_append_string (builder, new_pin);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_pin_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  PinType = ", line_prefix);
    {
        MbimPinType tmp;

        tmp = (MbimPinType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PIN_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_pin_type_get_string (tmp));
#elif defined __MBIM_PIN_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_pin_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinOperation = ", line_prefix);
    {
        MbimPinOperation tmp;

        tmp = (MbimPinOperation) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PIN_OPERATION_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_pin_operation_get_string (tmp));
#elif defined __MBIM_PIN_OPERATION_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_pin_operation_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Pin = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  NewPin = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Pin */

/**
 * mbim_message_pin_response_parse:
 * @message: the #MbimMessage.
 * @pin_type: return location for a #MbimPinType, or %NULL if the 'PinType' field is not needed.
 * @pin_state: return location for a #MbimPinState, or %NULL if the 'PinState' field is not needed.
 * @remaining_attempts: return location for a #guint32, or %NULL if the 'RemainingAttempts' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Pin' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_pin_response_parse (
    const MbimMessage *message,
    MbimPinType *pin_type,
    MbimPinState *pin_state,
    guint32 *remaining_attempts,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'PinType' variable */
    {
        if (pin_type != NULL)
            *pin_type =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'PinState' variable */
    {
        if (pin_state != NULL)
            *pin_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RemainingAttempts' variable */
    {
        if (remaining_attempts != NULL)
            *remaining_attempts =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_pin_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  PinType = ", line_prefix);
    {
        MbimPinType tmp;

        tmp = (MbimPinType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PIN_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_pin_type_get_string (tmp));
#elif defined __MBIM_PIN_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_pin_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinState = ", line_prefix);
    {
        MbimPinState tmp;

        tmp = (MbimPinState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PIN_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_pin_state_get_string (tmp));
#elif defined __MBIM_PIN_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_pin_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RemainingAttempts = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Pin List */

/**
 * mbim_message_pin_list_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Pin List' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_pin_list_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PIN_LIST,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_pin_list_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Pin List */

/**
 * mbim_message_pin_list_response_parse:
 * @message: the #MbimMessage.
 * @pin_desc_pin1: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescPin1' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_pin2: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescPin2' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_device_sim_pin: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescDeviceSimPin' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_device_first_sim_pin: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescDeviceFirstSimPin' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_network_pin: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescNetworkPin' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_network_subset_pin: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescNetworkSubsetPin' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_service_provider_pin: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescServiceProviderPin' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_corporate_pin: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescCorporatePin' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_subsidy_lock: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescSubsidyLock' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @pin_desc_custom: return location for a newly allocated #MbimPinDesc, or %NULL if the 'PinDescCustom' field is not needed. Free the returned value with mbim_pin_desc_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Pin List' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_pin_list_response_parse (
    const MbimMessage *message,
    MbimPinDesc **pin_desc_pin1,
    MbimPinDesc **pin_desc_pin2,
    MbimPinDesc **pin_desc_device_sim_pin,
    MbimPinDesc **pin_desc_device_first_sim_pin,
    MbimPinDesc **pin_desc_network_pin,
    MbimPinDesc **pin_desc_network_subset_pin,
    MbimPinDesc **pin_desc_service_provider_pin,
    MbimPinDesc **pin_desc_corporate_pin,
    MbimPinDesc **pin_desc_subsidy_lock,
    MbimPinDesc **pin_desc_custom,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'PinDescPin1' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_pin1 != NULL)
            *pin_desc_pin1 = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescPin2' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_pin2 != NULL)
            *pin_desc_pin2 = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescDeviceSimPin' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_device_sim_pin != NULL)
            *pin_desc_device_sim_pin = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescDeviceFirstSimPin' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_device_first_sim_pin != NULL)
            *pin_desc_device_first_sim_pin = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescNetworkPin' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_network_pin != NULL)
            *pin_desc_network_pin = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescNetworkSubsetPin' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_network_subset_pin != NULL)
            *pin_desc_network_subset_pin = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescServiceProviderPin' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_service_provider_pin != NULL)
            *pin_desc_service_provider_pin = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescCorporatePin' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_corporate_pin != NULL)
            *pin_desc_corporate_pin = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescSubsidyLock' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_subsidy_lock != NULL)
            *pin_desc_subsidy_lock = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    /* Read the 'PinDescCustom' variable */
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        if (pin_desc_custom != NULL)
            *pin_desc_custom = tmp;
        else
             _mbim_pin_desc_free (tmp);
        offset += bytes_read;
    }

    return TRUE;
}

static gchar *
mbim_message_pin_list_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  PinDescPin1 = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescPin2 = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescDeviceSimPin = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescDeviceFirstSimPin = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescNetworkPin = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescNetworkSubsetPin = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescServiceProviderPin = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescCorporatePin = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescSubsidyLock = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PinDescCustom = ", line_prefix);
    {
        MbimPinDesc *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_pin_desc_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_pin_desc_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_pin_desc_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Home Provider */

/**
 * mbim_message_home_provider_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Home Provider' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_home_provider_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_HOME_PROVIDER,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_home_provider_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Home Provider */

/**
 * mbim_message_home_provider_set_new:
 * @provider: the 'Provider' field, given as a #MbimProvider.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Home Provider' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_home_provider_set_new (
    const MbimProvider *provider,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_HOME_PROVIDER,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_mbim_provider_struct (builder, provider);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_home_provider_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Provider = ", line_prefix);
    {
        MbimProvider *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_provider_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_provider_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_provider_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Home Provider */

/**
 * mbim_message_home_provider_response_parse:
 * @message: the #MbimMessage.
 * @provider: return location for a newly allocated #MbimProvider, or %NULL if the 'Provider' field is not needed. Free the returned value with mbim_provider_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Home Provider' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_home_provider_response_parse (
    const MbimMessage *message,
    MbimProvider **provider,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Provider' variable */
    {
        MbimProvider *tmp;
        guint32 bytes_read = 0;

        tmp = _mbim_message_read_mbim_provider_struct (message, offset, &bytes_read);
        if (provider != NULL)
            *provider = tmp;
        else
             _mbim_provider_free (tmp);
        offset += bytes_read;
    }

    return TRUE;
}

static gchar *
mbim_message_home_provider_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Provider = ", line_prefix);
    {
        MbimProvider *tmp;
        guint32 bytes_read = 0;
        gchar *new_line_prefix;
        gchar *struct_str;

        tmp = _mbim_message_read_mbim_provider_struct (message, offset, &bytes_read);
        offset += bytes_read;

        g_string_append (str, "{\n");
        new_line_prefix = g_strdup_printf ("%s    ", line_prefix);
        struct_str = _mbim_message_print_mbim_provider_struct (tmp, new_line_prefix);
        g_string_append (str, struct_str);
        g_free (struct_str);
        g_string_append_printf (str, "%s  }\n", line_prefix);
        g_free (new_line_prefix);
        _mbim_provider_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Preferred Providers */

/**
 * mbim_message_preferred_providers_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Preferred Providers' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_preferred_providers_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PREFERRED_PROVIDERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_preferred_providers_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Preferred Providers */

/**
 * mbim_message_preferred_providers_set_new:
 * @providers_count: the 'ProvidersCount' field, given as a #guint32.
 * @providers: the 'Providers' field, given as an array of #MbimProviders.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Preferred Providers' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_preferred_providers_set_new (
    guint32 providers_count,
    const MbimProvider *const *providers,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PREFERRED_PROVIDERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, providers_count);
    }
    {
        _mbim_message_command_builder_append_mbim_provider_struct_array (builder, providers, providers_count, TRUE);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_preferred_providers_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Preferred Providers */

/**
 * mbim_message_preferred_providers_response_parse:
 * @message: the #MbimMessage.
 * @providers_count: return location for a #guint32, or %NULL if the 'ProvidersCount' field is not needed.
 * @providers: return location for a newly allocated array of #MbimProviders, or %NULL if the 'Providers' field is not needed. Free the returned value with mbim_provider_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Preferred Providers' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_preferred_providers_response_parse (
    const MbimMessage *message,
    guint32 *providers_count,
    MbimProvider ***providers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _providers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'ProvidersCount' variable */
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        if (providers_count != NULL)
            *providers_count = _providers_count;
        offset += 4;
    }

    /* Read the 'Providers' variable */
    {
        if (providers != NULL)
            *providers = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_preferred_providers_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Preferred Providers */

/**
 * mbim_message_preferred_providers_notification_parse:
 * @message: the #MbimMessage.
 * @providers_count: return location for a #guint32, or %NULL if the 'ProvidersCount' field is not needed.
 * @providers: return location for a newly allocated array of #MbimProviders, or %NULL if the 'Providers' field is not needed. Free the returned value with mbim_provider_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Preferred Providers' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_preferred_providers_notification_parse (
    const MbimMessage *message,
    guint32 *providers_count,
    MbimProvider ***providers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _providers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'ProvidersCount' variable */
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        if (providers_count != NULL)
            *providers_count = _providers_count;
        offset += 4;
    }

    /* Read the 'Providers' variable */
    {
        if (providers != NULL)
            *providers = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_preferred_providers_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Visible Providers */

/**
 * mbim_message_visible_providers_query_new:
 * @action: the 'Action' field, given as a #MbimVisibleProvidersAction.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Visible Providers' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_visible_providers_query_new (
    MbimVisibleProvidersAction action,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_VISIBLE_PROVIDERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);
    {
        _mbim_message_command_builder_append_guint32 (builder, action);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_visible_providers_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Action = ", line_prefix);
    {
        MbimVisibleProvidersAction tmp;

        tmp = (MbimVisibleProvidersAction) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_VISIBLE_PROVIDERS_ACTION_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_visible_providers_action_get_string (tmp));
#elif defined __MBIM_VISIBLE_PROVIDERS_ACTION_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_visible_providers_action_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Visible Providers */

/**
 * mbim_message_visible_providers_response_parse:
 * @message: the #MbimMessage.
 * @providers_count: return location for a #guint32, or %NULL if the 'ProvidersCount' field is not needed.
 * @providers: return location for a newly allocated array of #MbimProviders, or %NULL if the 'Providers' field is not needed. Free the returned value with mbim_provider_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Visible Providers' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_visible_providers_response_parse (
    const MbimMessage *message,
    guint32 *providers_count,
    MbimProvider ***providers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _providers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'ProvidersCount' variable */
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        if (providers_count != NULL)
            *providers_count = _providers_count;
        offset += 4;
    }

    /* Read the 'Providers' variable */
    {
        if (providers != NULL)
            *providers = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_visible_providers_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Register State */

/**
 * mbim_message_register_state_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Register State' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_register_state_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_REGISTER_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_register_state_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Register State */

/**
 * mbim_message_register_state_set_new:
 * @provider_id: the 'ProviderId' field, given as a string.
 * @register_action: the 'RegisterAction' field, given as a #MbimRegisterAction.
 * @data_class: the 'DataClass' field, given as a #MbimDataClass.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Register State' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_register_state_set_new (
    const gchar *provider_id,
    MbimRegisterAction register_action,
    MbimDataClass data_class,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_REGISTER_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_string (builder, provider_id);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, register_action);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, data_class);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_register_state_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProviderId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegisterAction = ", line_prefix);
    {
        MbimRegisterAction tmp;

        tmp = (MbimRegisterAction) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTER_ACTION_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_register_action_get_string (tmp));
#elif defined __MBIM_REGISTER_ACTION_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_register_action_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  DataClass = ", line_prefix);
    {
        MbimDataClass tmp;

        tmp = (MbimDataClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DATA_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_data_class_get_string (tmp));
#elif defined __MBIM_DATA_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_data_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Register State */

/**
 * mbim_message_register_state_response_parse:
 * @message: the #MbimMessage.
 * @nw_error: return location for a #MbimNwError, or %NULL if the 'NwError' field is not needed.
 * @register_state: return location for a #MbimRegisterState, or %NULL if the 'RegisterState' field is not needed.
 * @register_mode: return location for a #MbimRegisterMode, or %NULL if the 'RegisterMode' field is not needed.
 * @available_data_classes: return location for a #MbimDataClass, or %NULL if the 'AvailableDataClasses' field is not needed.
 * @current_cellular_class: return location for a #MbimCellularClass, or %NULL if the 'CurrentCellularClass' field is not needed.
 * @provider_id: return location for a newly allocated string, or %NULL if the 'ProviderId' field is not needed. Free the returned value with g_free().
 * @provider_name: return location for a newly allocated string, or %NULL if the 'ProviderName' field is not needed. Free the returned value with g_free().
 * @roaming_text: return location for a newly allocated string, or %NULL if the 'RoamingText' field is not needed. Free the returned value with g_free().
 * @registration_flag: return location for a #MbimRegistrationFlag, or %NULL if the 'RegistrationFlag' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Register State' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_register_state_response_parse (
    const MbimMessage *message,
    MbimNwError *nw_error,
    MbimRegisterState *register_state,
    MbimRegisterMode *register_mode,
    MbimDataClass *available_data_classes,
    MbimCellularClass *current_cellular_class,
    gchar **provider_id,
    gchar **provider_name,
    gchar **roaming_text,
    MbimRegistrationFlag *registration_flag,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RegisterState' variable */
    {
        if (register_state != NULL)
            *register_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RegisterMode' variable */
    {
        if (register_mode != NULL)
            *register_mode =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'AvailableDataClasses' variable */
    {
        if (available_data_classes != NULL)
            *available_data_classes =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CurrentCellularClass' variable */
    {
        if (current_cellular_class != NULL)
            *current_cellular_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ProviderId' variable */
    {
        if (provider_id != NULL)
            *provider_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'ProviderName' variable */
    {
        if (provider_name != NULL)
            *provider_name = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'RoamingText' variable */
    {
        if (roaming_text != NULL)
            *roaming_text = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'RegistrationFlag' variable */
    {
        if (registration_flag != NULL)
            *registration_flag =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_register_state_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        MbimNwError tmp;

        tmp = (MbimNwError) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_NW_ERROR_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_nw_error_get_string (tmp));
#elif defined __MBIM_NW_ERROR_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_nw_error_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegisterState = ", line_prefix);
    {
        MbimRegisterState tmp;

        tmp = (MbimRegisterState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTER_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_register_state_get_string (tmp));
#elif defined __MBIM_REGISTER_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_register_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegisterMode = ", line_prefix);
    {
        MbimRegisterMode tmp;

        tmp = (MbimRegisterMode) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTER_MODE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_register_mode_get_string (tmp));
#elif defined __MBIM_REGISTER_MODE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_register_mode_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  AvailableDataClasses = ", line_prefix);
    {
        MbimDataClass tmp;

        tmp = (MbimDataClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DATA_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_data_class_get_string (tmp));
#elif defined __MBIM_DATA_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_data_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CurrentCellularClass = ", line_prefix);
    {
        MbimCellularClass tmp;

        tmp = (MbimCellularClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CELLULAR_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_cellular_class_get_string (tmp));
#elif defined __MBIM_CELLULAR_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_cellular_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProviderId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProviderName = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RoamingText = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegistrationFlag = ", line_prefix);
    {
        MbimRegistrationFlag tmp;

        tmp = (MbimRegistrationFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTRATION_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_registration_flag_get_string (tmp));
#elif defined __MBIM_REGISTRATION_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_registration_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Register State */

/**
 * mbim_message_register_state_notification_parse:
 * @message: the #MbimMessage.
 * @nw_error: return location for a #MbimNwError, or %NULL if the 'NwError' field is not needed.
 * @register_state: return location for a #MbimRegisterState, or %NULL if the 'RegisterState' field is not needed.
 * @register_mode: return location for a #MbimRegisterMode, or %NULL if the 'RegisterMode' field is not needed.
 * @available_data_classes: return location for a #MbimDataClass, or %NULL if the 'AvailableDataClasses' field is not needed.
 * @current_cellular_class: return location for a #MbimCellularClass, or %NULL if the 'CurrentCellularClass' field is not needed.
 * @provider_id: return location for a newly allocated string, or %NULL if the 'ProviderId' field is not needed. Free the returned value with g_free().
 * @provider_name: return location for a newly allocated string, or %NULL if the 'ProviderName' field is not needed. Free the returned value with g_free().
 * @roaming_text: return location for a newly allocated string, or %NULL if the 'RoamingText' field is not needed. Free the returned value with g_free().
 * @registration_flag: return location for a #MbimRegistrationFlag, or %NULL if the 'RegistrationFlag' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Register State' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_register_state_notification_parse (
    const MbimMessage *message,
    MbimNwError *nw_error,
    MbimRegisterState *register_state,
    MbimRegisterMode *register_mode,
    MbimDataClass *available_data_classes,
    MbimCellularClass *current_cellular_class,
    gchar **provider_id,
    gchar **provider_name,
    gchar **roaming_text,
    MbimRegistrationFlag *registration_flag,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RegisterState' variable */
    {
        if (register_state != NULL)
            *register_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RegisterMode' variable */
    {
        if (register_mode != NULL)
            *register_mode =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'AvailableDataClasses' variable */
    {
        if (available_data_classes != NULL)
            *available_data_classes =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CurrentCellularClass' variable */
    {
        if (current_cellular_class != NULL)
            *current_cellular_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ProviderId' variable */
    {
        if (provider_id != NULL)
            *provider_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'ProviderName' variable */
    {
        if (provider_name != NULL)
            *provider_name = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'RoamingText' variable */
    {
        if (roaming_text != NULL)
            *roaming_text = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'RegistrationFlag' variable */
    {
        if (registration_flag != NULL)
            *registration_flag =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_register_state_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        MbimNwError tmp;

        tmp = (MbimNwError) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_NW_ERROR_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_nw_error_get_string (tmp));
#elif defined __MBIM_NW_ERROR_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_nw_error_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegisterState = ", line_prefix);
    {
        MbimRegisterState tmp;

        tmp = (MbimRegisterState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTER_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_register_state_get_string (tmp));
#elif defined __MBIM_REGISTER_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_register_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegisterMode = ", line_prefix);
    {
        MbimRegisterMode tmp;

        tmp = (MbimRegisterMode) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTER_MODE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_register_mode_get_string (tmp));
#elif defined __MBIM_REGISTER_MODE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_register_mode_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  AvailableDataClasses = ", line_prefix);
    {
        MbimDataClass tmp;

        tmp = (MbimDataClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DATA_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_data_class_get_string (tmp));
#elif defined __MBIM_DATA_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_data_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  CurrentCellularClass = ", line_prefix);
    {
        MbimCellularClass tmp;

        tmp = (MbimCellularClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CELLULAR_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_cellular_class_get_string (tmp));
#elif defined __MBIM_CELLULAR_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_cellular_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProviderId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProviderName = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RoamingText = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RegistrationFlag = ", line_prefix);
    {
        MbimRegistrationFlag tmp;

        tmp = (MbimRegistrationFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_REGISTRATION_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_registration_flag_get_string (tmp));
#elif defined __MBIM_REGISTRATION_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_registration_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Signal State */

/**
 * mbim_message_signal_state_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Signal State' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_signal_state_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_SIGNAL_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_signal_state_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Signal State */

/**
 * mbim_message_signal_state_set_new:
 * @signal_strength_interval: the 'SignalStrengthInterval' field, given as a #guint32.
 * @rssi_threshold: the 'RssiThreshold' field, given as a #guint32.
 * @error_rate_threshold: the 'ErrorRateThreshold' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Signal State' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_signal_state_set_new (
    guint32 signal_strength_interval,
    guint32 rssi_threshold,
    guint32 error_rate_threshold,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_SIGNAL_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, signal_strength_interval);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, rssi_threshold);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, error_rate_threshold);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_signal_state_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SignalStrengthInterval = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RssiThreshold = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ErrorRateThreshold = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Signal State */

/**
 * mbim_message_signal_state_response_parse:
 * @message: the #MbimMessage.
 * @rssi: return location for a #guint32, or %NULL if the 'Rssi' field is not needed.
 * @error_rate: return location for a #guint32, or %NULL if the 'ErrorRate' field is not needed.
 * @signal_strength_interval: return location for a #guint32, or %NULL if the 'SignalStrengthInterval' field is not needed.
 * @rssi_threshold: return location for a #guint32, or %NULL if the 'RssiThreshold' field is not needed.
 * @error_rate_threshold: return location for a #guint32, or %NULL if the 'ErrorRateThreshold' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Signal State' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_signal_state_response_parse (
    const MbimMessage *message,
    guint32 *rssi,
    guint32 *error_rate,
    guint32 *signal_strength_interval,
    guint32 *rssi_threshold,
    guint32 *error_rate_threshold,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Rssi' variable */
    {
        if (rssi != NULL)
            *rssi =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ErrorRate' variable */
    {
        if (error_rate != NULL)
            *error_rate =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SignalStrengthInterval' variable */
    {
        if (signal_strength_interval != NULL)
            *signal_strength_interval =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RssiThreshold' variable */
    {
        if (rssi_threshold != NULL)
            *rssi_threshold =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ErrorRateThreshold' variable */
    {
        if (error_rate_threshold != NULL)
            *error_rate_threshold =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_signal_state_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Rssi = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ErrorRate = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SignalStrengthInterval = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RssiThreshold = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ErrorRateThreshold = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Signal State */

/**
 * mbim_message_signal_state_notification_parse:
 * @message: the #MbimMessage.
 * @rssi: return location for a #guint32, or %NULL if the 'Rssi' field is not needed.
 * @error_rate: return location for a #guint32, or %NULL if the 'ErrorRate' field is not needed.
 * @signal_strength_interval: return location for a #guint32, or %NULL if the 'SignalStrengthInterval' field is not needed.
 * @rssi_threshold: return location for a #guint32, or %NULL if the 'RssiThreshold' field is not needed.
 * @error_rate_threshold: return location for a #guint32, or %NULL if the 'ErrorRateThreshold' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Signal State' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_signal_state_notification_parse (
    const MbimMessage *message,
    guint32 *rssi,
    guint32 *error_rate,
    guint32 *signal_strength_interval,
    guint32 *rssi_threshold,
    guint32 *error_rate_threshold,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'Rssi' variable */
    {
        if (rssi != NULL)
            *rssi =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ErrorRate' variable */
    {
        if (error_rate != NULL)
            *error_rate =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'SignalStrengthInterval' variable */
    {
        if (signal_strength_interval != NULL)
            *signal_strength_interval =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RssiThreshold' variable */
    {
        if (rssi_threshold != NULL)
            *rssi_threshold =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ErrorRateThreshold' variable */
    {
        if (error_rate_threshold != NULL)
            *error_rate_threshold =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_signal_state_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Rssi = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ErrorRate = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  SignalStrengthInterval = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  RssiThreshold = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ErrorRateThreshold = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Packet Service */

/**
 * mbim_message_packet_service_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Packet Service' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_packet_service_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PACKET_SERVICE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_packet_service_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Packet Service */

/**
 * mbim_message_packet_service_set_new:
 * @packet_service_action: the 'PacketServiceAction' field, given as a #MbimPacketServiceAction.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Packet Service' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_packet_service_set_new (
    MbimPacketServiceAction packet_service_action,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PACKET_SERVICE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, packet_service_action);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_packet_service_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  PacketServiceAction = ", line_prefix);
    {
        MbimPacketServiceAction tmp;

        tmp = (MbimPacketServiceAction) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PACKET_SERVICE_ACTION_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_packet_service_action_get_string (tmp));
#elif defined __MBIM_PACKET_SERVICE_ACTION_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_packet_service_action_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Packet Service */

/**
 * mbim_message_packet_service_response_parse:
 * @message: the #MbimMessage.
 * @nw_error: return location for a #guint32, or %NULL if the 'NwError' field is not needed.
 * @packet_service_state: return location for a #MbimPacketServiceState, or %NULL if the 'PacketServiceState' field is not needed.
 * @highest_available_data_class: return location for a #MbimDataClass, or %NULL if the 'HighestAvailableDataClass' field is not needed.
 * @uplink_speed: return location for a #guint64, or %NULL if the 'UplinkSpeed' field is not needed.
 * @downlink_speed: return location for a #guint64, or %NULL if the 'DownlinkSpeed' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Packet Service' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_packet_service_response_parse (
    const MbimMessage *message,
    guint32 *nw_error,
    MbimPacketServiceState *packet_service_state,
    MbimDataClass *highest_available_data_class,
    guint64 *uplink_speed,
    guint64 *downlink_speed,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'PacketServiceState' variable */
    {
        if (packet_service_state != NULL)
            *packet_service_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'HighestAvailableDataClass' variable */
    {
        if (highest_available_data_class != NULL)
            *highest_available_data_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'UplinkSpeed' variable */
    {
        if (uplink_speed != NULL)
            *uplink_speed =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    /* Read the 'DownlinkSpeed' variable */
    {
        if (downlink_speed != NULL)
            *downlink_speed =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    return TRUE;
}

static gchar *
mbim_message_packet_service_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketServiceState = ", line_prefix);
    {
        MbimPacketServiceState tmp;

        tmp = (MbimPacketServiceState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PACKET_SERVICE_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_packet_service_state_get_string (tmp));
#elif defined __MBIM_PACKET_SERVICE_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_packet_service_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  HighestAvailableDataClass = ", line_prefix);
    {
        MbimDataClass tmp;

        tmp = (MbimDataClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DATA_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_data_class_get_string (tmp));
#elif defined __MBIM_DATA_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_data_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  UplinkSpeed = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  DownlinkSpeed = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Packet Service */

/**
 * mbim_message_packet_service_notification_parse:
 * @message: the #MbimMessage.
 * @nw_error: return location for a #guint32, or %NULL if the 'NwError' field is not needed.
 * @packet_service_state: return location for a #MbimPacketServiceState, or %NULL if the 'PacketServiceState' field is not needed.
 * @highest_available_data_class: return location for a #MbimDataClass, or %NULL if the 'HighestAvailableDataClass' field is not needed.
 * @uplink_speed: return location for a #guint64, or %NULL if the 'UplinkSpeed' field is not needed.
 * @downlink_speed: return location for a #guint64, or %NULL if the 'DownlinkSpeed' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Packet Service' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_packet_service_notification_parse (
    const MbimMessage *message,
    guint32 *nw_error,
    MbimPacketServiceState *packet_service_state,
    MbimDataClass *highest_available_data_class,
    guint64 *uplink_speed,
    guint64 *downlink_speed,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'PacketServiceState' variable */
    {
        if (packet_service_state != NULL)
            *packet_service_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'HighestAvailableDataClass' variable */
    {
        if (highest_available_data_class != NULL)
            *highest_available_data_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'UplinkSpeed' variable */
    {
        if (uplink_speed != NULL)
            *uplink_speed =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    /* Read the 'DownlinkSpeed' variable */
    {
        if (downlink_speed != NULL)
            *downlink_speed =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    return TRUE;
}

static gchar *
mbim_message_packet_service_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketServiceState = ", line_prefix);
    {
        MbimPacketServiceState tmp;

        tmp = (MbimPacketServiceState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_PACKET_SERVICE_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_packet_service_state_get_string (tmp));
#elif defined __MBIM_PACKET_SERVICE_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_packet_service_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  HighestAvailableDataClass = ", line_prefix);
    {
        MbimDataClass tmp;

        tmp = (MbimDataClass) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_DATA_CLASS_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_data_class_get_string (tmp));
#elif defined __MBIM_DATA_CLASS_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_data_class_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  UplinkSpeed = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  DownlinkSpeed = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Connect */

/**
 * mbim_message_connect_query_new:
 * @session_id: the 'SessionId' field, given as a #guint32.
 * @activation_state: the 'ActivationState' field, given as a #MbimActivationState.
 * @voice_call_state: the 'VoiceCallState' field, given as a #MbimVoiceCallState.
 * @ip_type: the 'IpType' field, given as a #MbimContextIpType.
 * @context_type: the 'ContextType' field, given as a #MbimUuid.
 * @nw_error: the 'NwError' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Connect' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_connect_query_new (
    guint32 session_id,
    MbimActivationState activation_state,
    MbimVoiceCallState voice_call_state,
    MbimContextIpType ip_type,
    const MbimUuid *context_type,
    guint32 nw_error,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_CONNECT,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);
    {
        _mbim_message_command_builder_append_guint32 (builder, session_id);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, activation_state);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, voice_call_state);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ip_type);
    }
    {
        _mbim_message_command_builder_append_uuid (builder, context_type);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, nw_error);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_connect_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ActivationState = ", line_prefix);
    {
        MbimActivationState tmp;

        tmp = (MbimActivationState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_ACTIVATION_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_activation_state_get_string (tmp));
#elif defined __MBIM_ACTIVATION_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_activation_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  VoiceCallState = ", line_prefix);
    {
        MbimVoiceCallState tmp;

        tmp = (MbimVoiceCallState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_VOICE_CALL_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_voice_call_state_get_string (tmp));
#elif defined __MBIM_VOICE_CALL_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_voice_call_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IpType = ", line_prefix);
    {
        MbimContextIpType tmp;

        tmp = (MbimContextIpType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CONTEXT_IP_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_context_ip_type_get_string (tmp));
#elif defined __MBIM_CONTEXT_IP_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_context_ip_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ContextType = ", line_prefix);
    {
        const MbimUuid *tmp;
        gchar *tmpstr;

        tmp = _mbim_message_read_uuid (message, offset);
        offset += 16;
        tmpstr = mbim_uuid_get_printable (tmp);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Connect */

/**
 * mbim_message_connect_set_new:
 * @session_id: the 'SessionId' field, given as a #guint32.
 * @activation_command: the 'ActivationCommand' field, given as a #MbimActivationCommand.
 * @access_string: the 'AccessString' field, given as a string.
 * @user_name: the 'UserName' field, given as a string.
 * @password: the 'Password' field, given as a string.
 * @compression: the 'Compression' field, given as a #MbimCompression.
 * @auth_protocol: the 'AuthProtocol' field, given as a #MbimAuthProtocol.
 * @ip_type: the 'IpType' field, given as a #MbimContextIpType.
 * @context_type: the 'ContextType' field, given as a #MbimUuid.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Connect' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_connect_set_new (
    guint32 session_id,
    MbimActivationCommand activation_command,
    const gchar *access_string,
    const gchar *user_name,
    const gchar *password,
    MbimCompression compression,
    MbimAuthProtocol auth_protocol,
    MbimContextIpType ip_type,
    const MbimUuid *context_type,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_CONNECT,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, session_id);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, activation_command);
    }
    {
        _mbim_message_command_builder_append_string (builder, access_string);
    }
    {
        _mbim_message_command_builder_append_string (builder, user_name);
    }
    {
        _mbim_message_command_builder_append_string (builder, password);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, compression);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, auth_protocol);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ip_type);
    }
    {
        _mbim_message_command_builder_append_uuid (builder, context_type);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_connect_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ActivationCommand = ", line_prefix);
    {
        MbimActivationCommand tmp;

        tmp = (MbimActivationCommand) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_ACTIVATION_COMMAND_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_activation_command_get_string (tmp));
#elif defined __MBIM_ACTIVATION_COMMAND_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_activation_command_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  AccessString = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  UserName = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Password = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Compression = ", line_prefix);
    {
        MbimCompression tmp;

        tmp = (MbimCompression) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_COMPRESSION_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_compression_get_string (tmp));
#elif defined __MBIM_COMPRESSION_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_compression_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  AuthProtocol = ", line_prefix);
    {
        MbimAuthProtocol tmp;

        tmp = (MbimAuthProtocol) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_AUTH_PROTOCOL_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_auth_protocol_get_string (tmp));
#elif defined __MBIM_AUTH_PROTOCOL_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_auth_protocol_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IpType = ", line_prefix);
    {
        MbimContextIpType tmp;

        tmp = (MbimContextIpType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CONTEXT_IP_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_context_ip_type_get_string (tmp));
#elif defined __MBIM_CONTEXT_IP_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_context_ip_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ContextType = ", line_prefix);
    {
        const MbimUuid *tmp;
        gchar *tmpstr;

        tmp = _mbim_message_read_uuid (message, offset);
        offset += 16;
        tmpstr = mbim_uuid_get_printable (tmp);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Connect */

/**
 * mbim_message_connect_response_parse:
 * @message: the #MbimMessage.
 * @session_id: return location for a #guint32, or %NULL if the 'SessionId' field is not needed.
 * @activation_state: return location for a #MbimActivationState, or %NULL if the 'ActivationState' field is not needed.
 * @voice_call_state: return location for a #MbimVoiceCallState, or %NULL if the 'VoiceCallState' field is not needed.
 * @ip_type: return location for a #MbimContextIpType, or %NULL if the 'IpType' field is not needed.
 * @context_type: return location for a #MbimUuid, or %NULL if the 'ContextType' field is not needed. Do not free the returned value, it is owned by @message.
 * @nw_error: return location for a #guint32, or %NULL if the 'NwError' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Connect' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_connect_response_parse (
    const MbimMessage *message,
    guint32 *session_id,
    MbimActivationState *activation_state,
    MbimVoiceCallState *voice_call_state,
    MbimContextIpType *ip_type,
    const MbimUuid **context_type,
    guint32 *nw_error,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'SessionId' variable */
    {
        if (session_id != NULL)
            *session_id =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ActivationState' variable */
    {
        if (activation_state != NULL)
            *activation_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'VoiceCallState' variable */
    {
        if (voice_call_state != NULL)
            *voice_call_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IpType' variable */
    {
        if (ip_type != NULL)
            *ip_type =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ContextType' variable */
    {
        if (context_type != NULL)
            *context_type =  _mbim_message_read_uuid (message, offset);
        offset += 16;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_connect_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ActivationState = ", line_prefix);
    {
        MbimActivationState tmp;

        tmp = (MbimActivationState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_ACTIVATION_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_activation_state_get_string (tmp));
#elif defined __MBIM_ACTIVATION_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_activation_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  VoiceCallState = ", line_prefix);
    {
        MbimVoiceCallState tmp;

        tmp = (MbimVoiceCallState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_VOICE_CALL_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_voice_call_state_get_string (tmp));
#elif defined __MBIM_VOICE_CALL_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_voice_call_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IpType = ", line_prefix);
    {
        MbimContextIpType tmp;

        tmp = (MbimContextIpType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CONTEXT_IP_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_context_ip_type_get_string (tmp));
#elif defined __MBIM_CONTEXT_IP_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_context_ip_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ContextType = ", line_prefix);
    {
        const MbimUuid *tmp;
        gchar *tmpstr;

        tmp = _mbim_message_read_uuid (message, offset);
        offset += 16;
        tmpstr = mbim_uuid_get_printable (tmp);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Connect */

/**
 * mbim_message_connect_notification_parse:
 * @message: the #MbimMessage.
 * @session_id: return location for a #guint32, or %NULL if the 'SessionId' field is not needed.
 * @activation_state: return location for a #MbimActivationState, or %NULL if the 'ActivationState' field is not needed.
 * @voice_call_state: return location for a #MbimVoiceCallState, or %NULL if the 'VoiceCallState' field is not needed.
 * @ip_type: return location for a #MbimContextIpType, or %NULL if the 'IpType' field is not needed.
 * @context_type: return location for a #MbimUuid, or %NULL if the 'ContextType' field is not needed. Do not free the returned value, it is owned by @message.
 * @nw_error: return location for a #guint32, or %NULL if the 'NwError' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Connect' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_connect_notification_parse (
    const MbimMessage *message,
    guint32 *session_id,
    MbimActivationState *activation_state,
    MbimVoiceCallState *voice_call_state,
    MbimContextIpType *ip_type,
    const MbimUuid **context_type,
    guint32 *nw_error,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'SessionId' variable */
    {
        if (session_id != NULL)
            *session_id =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ActivationState' variable */
    {
        if (activation_state != NULL)
            *activation_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'VoiceCallState' variable */
    {
        if (voice_call_state != NULL)
            *voice_call_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IpType' variable */
    {
        if (ip_type != NULL)
            *ip_type =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ContextType' variable */
    {
        if (context_type != NULL)
            *context_type =  _mbim_message_read_uuid (message, offset);
        offset += 16;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_connect_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ActivationState = ", line_prefix);
    {
        MbimActivationState tmp;

        tmp = (MbimActivationState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_ACTIVATION_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_activation_state_get_string (tmp));
#elif defined __MBIM_ACTIVATION_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_activation_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  VoiceCallState = ", line_prefix);
    {
        MbimVoiceCallState tmp;

        tmp = (MbimVoiceCallState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_VOICE_CALL_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_voice_call_state_get_string (tmp));
#elif defined __MBIM_VOICE_CALL_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_voice_call_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IpType = ", line_prefix);
    {
        MbimContextIpType tmp;

        tmp = (MbimContextIpType) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_CONTEXT_IP_TYPE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_context_ip_type_get_string (tmp));
#elif defined __MBIM_CONTEXT_IP_TYPE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_context_ip_type_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ContextType = ", line_prefix);
    {
        const MbimUuid *tmp;
        gchar *tmpstr;

        tmp = _mbim_message_read_uuid (message, offset);
        offset += 16;
        tmpstr = mbim_uuid_get_printable (tmp);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Provisioned Contexts */

/**
 * mbim_message_provisioned_contexts_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Provisioned Contexts' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_provisioned_contexts_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PROVISIONED_CONTEXTS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_provisioned_contexts_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Provisioned Contexts */

/**
 * mbim_message_provisioned_contexts_set_new:
 * @context_id: the 'ContextId' field, given as a #guint32.
 * @context_type: the 'ContextType' field, given as a #MbimUuid.
 * @access_string: the 'AccessString' field, given as a string.
 * @user_name: the 'UserName' field, given as a string.
 * @password: the 'Password' field, given as a string.
 * @compression: the 'Compression' field, given as a #MbimCompression.
 * @auth_protocol: the 'AuthProtocol' field, given as a #MbimAuthProtocol.
 * @provider_id: the 'ProviderId' field, given as a string.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Provisioned Contexts' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_provisioned_contexts_set_new (
    guint32 context_id,
    const MbimUuid *context_type,
    const gchar *access_string,
    const gchar *user_name,
    const gchar *password,
    MbimCompression compression,
    MbimAuthProtocol auth_protocol,
    const gchar *provider_id,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PROVISIONED_CONTEXTS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, context_id);
    }
    {
        _mbim_message_command_builder_append_uuid (builder, context_type);
    }
    {
        _mbim_message_command_builder_append_string (builder, access_string);
    }
    {
        _mbim_message_command_builder_append_string (builder, user_name);
    }
    {
        _mbim_message_command_builder_append_string (builder, password);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, compression);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, auth_protocol);
    }
    {
        _mbim_message_command_builder_append_string (builder, provider_id);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_provisioned_contexts_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ContextId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ContextType = ", line_prefix);
    {
        const MbimUuid *tmp;
        gchar *tmpstr;

        tmp = _mbim_message_read_uuid (message, offset);
        offset += 16;
        tmpstr = mbim_uuid_get_printable (tmp);
        g_string_append_printf (str, "'%s'", tmpstr);
        g_free (tmpstr);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  AccessString = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  UserName = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Password = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Compression = ", line_prefix);
    {
        MbimCompression tmp;

        tmp = (MbimCompression) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_COMPRESSION_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_compression_get_string (tmp));
#elif defined __MBIM_COMPRESSION_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_compression_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  AuthProtocol = ", line_prefix);
    {
        MbimAuthProtocol tmp;

        tmp = (MbimAuthProtocol) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_AUTH_PROTOCOL_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_auth_protocol_get_string (tmp));
#elif defined __MBIM_AUTH_PROTOCOL_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_auth_protocol_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProviderId = ", line_prefix);
    {
        gchar *tmp;

        tmp = _mbim_message_read_string (message, 0, offset);
        offset += 8;
        g_string_append_printf (str, "'%s'", tmp);
        g_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Provisioned Contexts */

/**
 * mbim_message_provisioned_contexts_response_parse:
 * @message: the #MbimMessage.
 * @provisioned_contexts_count: return location for a #guint32, or %NULL if the 'ProvisionedContextsCount' field is not needed.
 * @provisioned_contexts: return location for a newly allocated array of #MbimProvisionedContextElements, or %NULL if the 'ProvisionedContexts' field is not needed. Free the returned value with mbim_provisioned_context_element_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Provisioned Contexts' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_provisioned_contexts_response_parse (
    const MbimMessage *message,
    guint32 *provisioned_contexts_count,
    MbimProvisionedContextElement ***provisioned_contexts,
    GError **error)
{
    guint32 offset = 0;
    guint32 _provisioned_contexts_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'ProvisionedContextsCount' variable */
    {
        _provisioned_contexts_count = _mbim_message_read_guint32 (message, offset);
        if (provisioned_contexts_count != NULL)
            *provisioned_contexts_count = _provisioned_contexts_count;
        offset += 4;
    }

    /* Read the 'ProvisionedContexts' variable */
    {
        if (provisioned_contexts != NULL)
            *provisioned_contexts = _mbim_message_read_mbim_provisioned_context_element_struct_array (message, _provisioned_contexts_count, offset, TRUE);
        offset += (8 * _provisioned_contexts_count);
    }

    return TRUE;
}

static gchar *
mbim_message_provisioned_contexts_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _provisioned_contexts_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvisionedContextsCount = ", line_prefix);
    {
        _provisioned_contexts_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _provisioned_contexts_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProvisionedContexts = ", line_prefix);
    {
        MbimProvisionedContextElement **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provisioned_context_element_struct_array (message, _provisioned_contexts_count, offset, TRUE);
        offset += (8 * _provisioned_contexts_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _provisioned_contexts_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provisioned_context_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provisioned_context_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Provisioned Contexts */

/**
 * mbim_message_provisioned_contexts_notification_parse:
 * @message: the #MbimMessage.
 * @provisioned_contexts_count: return location for a #guint32, or %NULL if the 'ProvisionedContextsCount' field is not needed.
 * @provisioned_contexts: return location for a newly allocated array of #MbimProvisionedContextElements, or %NULL if the 'ProvisionedContexts' field is not needed. Free the returned value with mbim_provisioned_context_element_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Provisioned Contexts' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_provisioned_contexts_notification_parse (
    const MbimMessage *message,
    guint32 *provisioned_contexts_count,
    MbimProvisionedContextElement ***provisioned_contexts,
    GError **error)
{
    guint32 offset = 0;
    guint32 _provisioned_contexts_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'ProvisionedContextsCount' variable */
    {
        _provisioned_contexts_count = _mbim_message_read_guint32 (message, offset);
        if (provisioned_contexts_count != NULL)
            *provisioned_contexts_count = _provisioned_contexts_count;
        offset += 4;
    }

    /* Read the 'ProvisionedContexts' variable */
    {
        if (provisioned_contexts != NULL)
            *provisioned_contexts = _mbim_message_read_mbim_provisioned_context_element_struct_array (message, _provisioned_contexts_count, offset, TRUE);
        offset += (8 * _provisioned_contexts_count);
    }

    return TRUE;
}

static gchar *
mbim_message_provisioned_contexts_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _provisioned_contexts_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvisionedContextsCount = ", line_prefix);
    {
        _provisioned_contexts_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _provisioned_contexts_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  ProvisionedContexts = ", line_prefix);
    {
        MbimProvisionedContextElement **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provisioned_context_element_struct_array (message, _provisioned_contexts_count, offset, TRUE);
        offset += (8 * _provisioned_contexts_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _provisioned_contexts_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provisioned_context_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provisioned_context_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Service Activation */

/**
 * mbim_message_service_activation_set_new:
 * @buffer_size: size of the buffer array.
 * @buffer: the 'Buffer' field, given as an array of #guint8 values.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Service Activation' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_service_activation_set_new (
    const guint32 buffer_size,
    const guint8 *buffer,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_SERVICE_ACTIVATION,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_byte_array (builder, FALSE, FALSE, TRUE, buffer, buffer_size);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_service_activation_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  Buffer = ", line_prefix);
    {
        guint i;
        const guint8 *tmp;
        guint32 tmpsize;

        tmp = _mbim_message_read_byte_array (message, 0, offset, FALSE, FALSE, &tmpsize);
        offset += tmpsize;
        g_string_append (str, "'");
        for (i = 0; i  < tmpsize; i++)
            g_string_append_printf (str, "%02x%s", tmp[i], (i == (tmpsize - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Service Activation */

/**
 * mbim_message_service_activation_response_parse:
 * @message: the #MbimMessage.
 * @nw_error: return location for a #MbimNwError, or %NULL if the 'NwError' field is not needed.
 * @buffer_size: return location for the size of the buffer array.
 * @buffer: return location for an array of #guint8 values. Do not free the returned value, it is owned by @message.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Service Activation' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_service_activation_response_parse (
    const MbimMessage *message,
    MbimNwError *nw_error,
    guint32 *buffer_size,
    const guint8 **buffer,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Buffer' variable */
    {
        const guint8 *tmp;
        guint32 tmpsize;

        tmp = _mbim_message_read_byte_array (message, 0, offset, FALSE, FALSE, &tmpsize);
        if (buffer != NULL)
            *buffer = tmp;
        if (buffer_size != NULL)
            *buffer_size = tmpsize;
        offset += tmpsize;
    }

    return TRUE;
}

static gchar *
mbim_message_service_activation_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  NwError = ", line_prefix);
    {
        MbimNwError tmp;

        tmp = (MbimNwError) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_NW_ERROR_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_nw_error_get_string (tmp));
#elif defined __MBIM_NW_ERROR_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_nw_error_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Buffer = ", line_prefix);
    {
        guint i;
        const guint8 *tmp;
        guint32 tmpsize;

        tmp = _mbim_message_read_byte_array (message, 0, offset, FALSE, FALSE, &tmpsize);
        offset += tmpsize;
        g_string_append (str, "'");
        for (i = 0; i  < tmpsize; i++)
            g_string_append_printf (str, "%02x%s", tmp[i], (i == (tmpsize - 1)) ? "" : ":" );
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message IP Configuration */

/**
 * mbim_message_ip_configuration_query_new:
 * @session_id: the 'SessionId' field, given as a #guint32.
 * @ipv4_configuration_available: the 'IPv4ConfigurationAvailable' field, given as a #MbimIPConfigurationAvailableFlag.
 * @ipv6_configuration_available: the 'IPv6ConfigurationAvailable' field, given as a #MbimIPConfigurationAvailableFlag.
 * @ipv4_address_count: the 'IPv4AddressCount' field, given as a #guint32.
 * @ipv4_address: the 'IPv4Address' field, given as an array of #MbimIPv4Elements.
 * @ipv6_address_count: the 'IPv6AddressCount' field, given as a #guint32.
 * @ipv6_address: the 'IPv6Address' field, given as an array of #MbimIPv6Elements.
 * @ipv4_gateway: the 'IPv4Gateway' field, given as a #MbimIPv4.
 * @ipv6_gateway: the 'IPv6Gateway' field, given as a #MbimIPv6.
 * @ipv4_dns_server_count: the 'IPv4DnsServerCount' field, given as a #guint32.
 * @ipv4_dns_server: the 'IPv4DnsServer' field, given as an array of #MbimIPv4.
 * @ipv6_dns_server_count: the 'IPv6DnsServerCount' field, given as a #guint32.
 * @ipv6_dns_server: the 'IPv6DnsServer' field, given as an array of #MbimIPv6.
 * @ipv4_mtu: the 'IPv4Mtu' field, given as a #guint32.
 * @ipv6_mtu: the 'IPv6Mtu' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'IP Configuration' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_ip_configuration_query_new (
    guint32 session_id,
    MbimIPConfigurationAvailableFlag ipv4_configuration_available,
    MbimIPConfigurationAvailableFlag ipv6_configuration_available,
    guint32 ipv4_address_count,
    const MbimIPv4Element *const *ipv4_address,
    guint32 ipv6_address_count,
    const MbimIPv6Element *const *ipv6_address,
    const MbimIPv4 *ipv4_gateway,
    const MbimIPv6 *ipv6_gateway,
    guint32 ipv4_dns_server_count,
    const MbimIPv4 *ipv4_dns_server,
    guint32 ipv6_dns_server_count,
    const MbimIPv6 *ipv6_dns_server,
    guint32 ipv4_mtu,
    guint32 ipv6_mtu,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_IP_CONFIGURATION,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);
    {
        _mbim_message_command_builder_append_guint32 (builder, session_id);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv4_configuration_available);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv6_configuration_available);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv4_address_count);
    }
    {
        _mbim_message_command_builder_append_mbim_ipv4_element_struct_array (builder, ipv4_address, ipv4_address_count, FALSE);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv6_address_count);
    }
    {
        _mbim_message_command_builder_append_mbim_ipv6_element_struct_array (builder, ipv6_address, ipv6_address_count, FALSE);
    }
    {
        _mbim_message_command_builder_append_ipv4 (builder, ipv4_gateway, TRUE);
    }
    {
        _mbim_message_command_builder_append_ipv6 (builder, ipv6_gateway, TRUE);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv4_dns_server_count);
    }
    {
        _mbim_message_command_builder_append_ipv4_array (builder, ipv4_dns_server, ipv4_dns_server_count);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv6_dns_server_count);
    }
    {
        _mbim_message_command_builder_append_ipv6_array (builder, ipv6_dns_server, ipv6_dns_server_count);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv4_mtu);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, ipv6_mtu);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_ip_configuration_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _ipv4_address_count;
    guint32 _ipv6_address_count;
    guint32 _ipv4_dns_server_count;
    guint32 _ipv6_dns_server_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4ConfigurationAvailable = ", line_prefix);
    {
        MbimIPConfigurationAvailableFlag tmp;

        tmp = (MbimIPConfigurationAvailableFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ip_configuration_available_flag_get_string (tmp));
#elif defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ip_configuration_available_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6ConfigurationAvailable = ", line_prefix);
    {
        MbimIPConfigurationAvailableFlag tmp;

        tmp = (MbimIPConfigurationAvailableFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ip_configuration_available_flag_get_string (tmp));
#elif defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ip_configuration_available_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4AddressCount = ", line_prefix);
    {
        _ipv4_address_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv4_address_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Address = ", line_prefix);
    {
        MbimIPv4Element **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_ipv4_element_struct_array (message, _ipv4_address_count, offset, FALSE);
        offset += 4;
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _ipv4_address_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_ipv4_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_ipv4_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6AddressCount = ", line_prefix);
    {
        _ipv6_address_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv6_address_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Address = ", line_prefix);
    {
        MbimIPv6Element **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_ipv6_element_struct_array (message, _ipv6_address_count, offset, FALSE);
        offset += 4;
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _ipv6_address_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_ipv6_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_ipv6_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Gateway = ", line_prefix);
    {
        const MbimIPv4 *tmp;
        guint array_size;
        guint i;

        array_size = 1;
        tmp = _mbim_message_read_ipv4 (message, offset, TRUE);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV4);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Gateway = ", line_prefix);
    {
        const MbimIPv6 *tmp;
        guint array_size;
        guint i;

        array_size = 1;
        tmp = _mbim_message_read_ipv6 (message, offset, TRUE);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV6);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4DnsServerCount = ", line_prefix);
    {
        _ipv4_dns_server_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv4_dns_server_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4DnsServer = ", line_prefix);
    {
        MbimIPv4 *tmp;
        guint array_size;
        guint i;

        array_size = _ipv4_dns_server_count;
        tmp = _mbim_message_read_ipv4_array (message, _ipv4_dns_server_count, offset);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV4);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6DnsServerCount = ", line_prefix);
    {
        _ipv6_dns_server_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv6_dns_server_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6DnsServer = ", line_prefix);
    {
        MbimIPv6 *tmp;
        guint array_size;
        guint i;

        array_size = _ipv6_dns_server_count;
        tmp = _mbim_message_read_ipv6_array (message, _ipv6_dns_server_count, offset);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV6);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Mtu = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Mtu = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message IP Configuration */

/**
 * mbim_message_ip_configuration_response_parse:
 * @message: the #MbimMessage.
 * @session_id: return location for a #guint32, or %NULL if the 'SessionId' field is not needed.
 * @ipv4_configuration_available: return location for a #MbimIPConfigurationAvailableFlag, or %NULL if the 'IPv4ConfigurationAvailable' field is not needed.
 * @ipv6_configuration_available: return location for a #MbimIPConfigurationAvailableFlag, or %NULL if the 'IPv6ConfigurationAvailable' field is not needed.
 * @ipv4_address_count: return location for a #guint32, or %NULL if the 'IPv4AddressCount' field is not needed.
 * @ipv4_address: return location for a newly allocated array of #MbimIPv4Elements, or %NULL if the 'IPv4Address' field is not needed. Free the returned value with mbim_ipv4_element_array_free().
 * @ipv6_address_count: return location for a #guint32, or %NULL if the 'IPv6AddressCount' field is not needed.
 * @ipv6_address: return location for a newly allocated array of #MbimIPv6Elements, or %NULL if the 'IPv6Address' field is not needed. Free the returned value with mbim_ipv6_element_array_free().
 * @ipv4_gateway: return location for a #MbimIPv4, or %NULL if the 'IPv4Gateway' field is not needed. Do not free the returned value, it is owned by @message.
 * @ipv6_gateway: return location for a #MbimIPv6, or %NULL if the 'IPv6Gateway' field is not needed. Do not free the returned value, it is owned by @message.
 * @ipv4_dns_server_count: return location for a #guint32, or %NULL if the 'IPv4DnsServerCount' field is not needed.
 * @ipv4_dns_server: return location for a newly allocated array of #MbimIPv4s, or %NULL if the 'IPv4DnsServer' field is not needed. Free the returned value with g_free().
 * @ipv6_dns_server_count: return location for a #guint32, or %NULL if the 'IPv6DnsServerCount' field is not needed.
 * @ipv6_dns_server: return location for a newly allocated array of #MbimIPv6s, or %NULL if the 'IPv6DnsServer' field is not needed. Free the returned value with g_free().
 * @ipv4_mtu: return location for a #guint32, or %NULL if the 'IPv4Mtu' field is not needed.
 * @ipv6_mtu: return location for a #guint32, or %NULL if the 'IPv6Mtu' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'IP Configuration' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_ip_configuration_response_parse (
    const MbimMessage *message,
    guint32 *session_id,
    MbimIPConfigurationAvailableFlag *ipv4_configuration_available,
    MbimIPConfigurationAvailableFlag *ipv6_configuration_available,
    guint32 *ipv4_address_count,
    MbimIPv4Element ***ipv4_address,
    guint32 *ipv6_address_count,
    MbimIPv6Element ***ipv6_address,
    const MbimIPv4 **ipv4_gateway,
    const MbimIPv6 **ipv6_gateway,
    guint32 *ipv4_dns_server_count,
    MbimIPv4 **ipv4_dns_server,
    guint32 *ipv6_dns_server_count,
    MbimIPv6 **ipv6_dns_server,
    guint32 *ipv4_mtu,
    guint32 *ipv6_mtu,
    GError **error)
{
    guint32 offset = 0;
    guint32 _ipv4_address_count;
    guint32 _ipv6_address_count;
    guint32 _ipv4_dns_server_count;
    guint32 _ipv6_dns_server_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'SessionId' variable */
    {
        if (session_id != NULL)
            *session_id =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv4ConfigurationAvailable' variable */
    {
        if (ipv4_configuration_available != NULL)
            *ipv4_configuration_available =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv6ConfigurationAvailable' variable */
    {
        if (ipv6_configuration_available != NULL)
            *ipv6_configuration_available =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv4AddressCount' variable */
    {
        _ipv4_address_count = _mbim_message_read_guint32 (message, offset);
        if (ipv4_address_count != NULL)
            *ipv4_address_count = _ipv4_address_count;
        offset += 4;
    }

    /* Read the 'IPv4Address' variable */
    {
        if (ipv4_address != NULL)
            *ipv4_address = _mbim_message_read_mbim_ipv4_element_struct_array (message, _ipv4_address_count, offset, FALSE);
        offset += 4;
    }

    /* Read the 'IPv6AddressCount' variable */
    {
        _ipv6_address_count = _mbim_message_read_guint32 (message, offset);
        if (ipv6_address_count != NULL)
            *ipv6_address_count = _ipv6_address_count;
        offset += 4;
    }

    /* Read the 'IPv6Address' variable */
    {
        if (ipv6_address != NULL)
            *ipv6_address = _mbim_message_read_mbim_ipv6_element_struct_array (message, _ipv6_address_count, offset, FALSE);
        offset += 4;
    }

    /* Read the 'IPv4Gateway' variable */
    {
        if (ipv4_gateway != NULL)
            *ipv4_gateway =  _mbim_message_read_ipv4 (message, offset, TRUE);
        offset += 4;
    }

    /* Read the 'IPv6Gateway' variable */
    {
        if (ipv6_gateway != NULL)
            *ipv6_gateway =  _mbim_message_read_ipv6 (message, offset, TRUE);
        offset += 4;
    }

    /* Read the 'IPv4DnsServerCount' variable */
    {
        _ipv4_dns_server_count = _mbim_message_read_guint32 (message, offset);
        if (ipv4_dns_server_count != NULL)
            *ipv4_dns_server_count = _ipv4_dns_server_count;
        offset += 4;
    }

    /* Read the 'IPv4DnsServer' variable */
    {
        if (ipv4_dns_server != NULL)
            *ipv4_dns_server =  _mbim_message_read_ipv4_array (message, _ipv4_dns_server_count, offset);
        offset += 4;
    }

    /* Read the 'IPv6DnsServerCount' variable */
    {
        _ipv6_dns_server_count = _mbim_message_read_guint32 (message, offset);
        if (ipv6_dns_server_count != NULL)
            *ipv6_dns_server_count = _ipv6_dns_server_count;
        offset += 4;
    }

    /* Read the 'IPv6DnsServer' variable */
    {
        if (ipv6_dns_server != NULL)
            *ipv6_dns_server =  _mbim_message_read_ipv6_array (message, _ipv6_dns_server_count, offset);
        offset += 4;
    }

    /* Read the 'IPv4Mtu' variable */
    {
        if (ipv4_mtu != NULL)
            *ipv4_mtu =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv6Mtu' variable */
    {
        if (ipv6_mtu != NULL)
            *ipv6_mtu =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_ip_configuration_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _ipv4_address_count;
    guint32 _ipv6_address_count;
    guint32 _ipv4_dns_server_count;
    guint32 _ipv6_dns_server_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4ConfigurationAvailable = ", line_prefix);
    {
        MbimIPConfigurationAvailableFlag tmp;

        tmp = (MbimIPConfigurationAvailableFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ip_configuration_available_flag_get_string (tmp));
#elif defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ip_configuration_available_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6ConfigurationAvailable = ", line_prefix);
    {
        MbimIPConfigurationAvailableFlag tmp;

        tmp = (MbimIPConfigurationAvailableFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ip_configuration_available_flag_get_string (tmp));
#elif defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ip_configuration_available_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4AddressCount = ", line_prefix);
    {
        _ipv4_address_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv4_address_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Address = ", line_prefix);
    {
        MbimIPv4Element **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_ipv4_element_struct_array (message, _ipv4_address_count, offset, FALSE);
        offset += 4;
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _ipv4_address_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_ipv4_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_ipv4_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6AddressCount = ", line_prefix);
    {
        _ipv6_address_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv6_address_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Address = ", line_prefix);
    {
        MbimIPv6Element **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_ipv6_element_struct_array (message, _ipv6_address_count, offset, FALSE);
        offset += 4;
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _ipv6_address_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_ipv6_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_ipv6_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Gateway = ", line_prefix);
    {
        const MbimIPv4 *tmp;
        guint array_size;
        guint i;

        array_size = 1;
        tmp = _mbim_message_read_ipv4 (message, offset, TRUE);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV4);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Gateway = ", line_prefix);
    {
        const MbimIPv6 *tmp;
        guint array_size;
        guint i;

        array_size = 1;
        tmp = _mbim_message_read_ipv6 (message, offset, TRUE);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV6);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4DnsServerCount = ", line_prefix);
    {
        _ipv4_dns_server_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv4_dns_server_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4DnsServer = ", line_prefix);
    {
        MbimIPv4 *tmp;
        guint array_size;
        guint i;

        array_size = _ipv4_dns_server_count;
        tmp = _mbim_message_read_ipv4_array (message, _ipv4_dns_server_count, offset);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV4);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6DnsServerCount = ", line_prefix);
    {
        _ipv6_dns_server_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv6_dns_server_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6DnsServer = ", line_prefix);
    {
        MbimIPv6 *tmp;
        guint array_size;
        guint i;

        array_size = _ipv6_dns_server_count;
        tmp = _mbim_message_read_ipv6_array (message, _ipv6_dns_server_count, offset);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV6);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Mtu = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Mtu = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message IP Configuration */

/**
 * mbim_message_ip_configuration_notification_parse:
 * @message: the #MbimMessage.
 * @session_id: return location for a #guint32, or %NULL if the 'SessionId' field is not needed.
 * @ipv4_configuration_available: return location for a #MbimIPConfigurationAvailableFlag, or %NULL if the 'IPv4ConfigurationAvailable' field is not needed.
 * @ipv6_configuration_available: return location for a #MbimIPConfigurationAvailableFlag, or %NULL if the 'IPv6ConfigurationAvailable' field is not needed.
 * @ipv4_address_count: return location for a #guint32, or %NULL if the 'IPv4AddressCount' field is not needed.
 * @ipv4_address: return location for a newly allocated array of #MbimIPv4Elements, or %NULL if the 'IPv4Address' field is not needed. Free the returned value with mbim_ipv4_element_array_free().
 * @ipv6_address_count: return location for a #guint32, or %NULL if the 'IPv6AddressCount' field is not needed.
 * @ipv6_address: return location for a newly allocated array of #MbimIPv6Elements, or %NULL if the 'IPv6Address' field is not needed. Free the returned value with mbim_ipv6_element_array_free().
 * @ipv4_gateway: return location for a #MbimIPv4, or %NULL if the 'IPv4Gateway' field is not needed. Do not free the returned value, it is owned by @message.
 * @ipv6_gateway: return location for a #MbimIPv6, or %NULL if the 'IPv6Gateway' field is not needed. Do not free the returned value, it is owned by @message.
 * @ipv4_dns_server_count: return location for a #guint32, or %NULL if the 'IPv4DnsServerCount' field is not needed.
 * @ipv4_dns_server: return location for a newly allocated array of #MbimIPv4s, or %NULL if the 'IPv4DnsServer' field is not needed. Free the returned value with g_free().
 * @ipv6_dns_server_count: return location for a #guint32, or %NULL if the 'IPv6DnsServerCount' field is not needed.
 * @ipv6_dns_server: return location for a newly allocated array of #MbimIPv6s, or %NULL if the 'IPv6DnsServer' field is not needed. Free the returned value with g_free().
 * @ipv4_mtu: return location for a #guint32, or %NULL if the 'IPv4Mtu' field is not needed.
 * @ipv6_mtu: return location for a #guint32, or %NULL if the 'IPv6Mtu' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'IP Configuration' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_ip_configuration_notification_parse (
    const MbimMessage *message,
    guint32 *session_id,
    MbimIPConfigurationAvailableFlag *ipv4_configuration_available,
    MbimIPConfigurationAvailableFlag *ipv6_configuration_available,
    guint32 *ipv4_address_count,
    MbimIPv4Element ***ipv4_address,
    guint32 *ipv6_address_count,
    MbimIPv6Element ***ipv6_address,
    const MbimIPv4 **ipv4_gateway,
    const MbimIPv6 **ipv6_gateway,
    guint32 *ipv4_dns_server_count,
    MbimIPv4 **ipv4_dns_server,
    guint32 *ipv6_dns_server_count,
    MbimIPv6 **ipv6_dns_server,
    guint32 *ipv4_mtu,
    guint32 *ipv6_mtu,
    GError **error)
{
    guint32 offset = 0;
    guint32 _ipv4_address_count;
    guint32 _ipv6_address_count;
    guint32 _ipv4_dns_server_count;
    guint32 _ipv6_dns_server_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'SessionId' variable */
    {
        if (session_id != NULL)
            *session_id =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv4ConfigurationAvailable' variable */
    {
        if (ipv4_configuration_available != NULL)
            *ipv4_configuration_available =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv6ConfigurationAvailable' variable */
    {
        if (ipv6_configuration_available != NULL)
            *ipv6_configuration_available =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv4AddressCount' variable */
    {
        _ipv4_address_count = _mbim_message_read_guint32 (message, offset);
        if (ipv4_address_count != NULL)
            *ipv4_address_count = _ipv4_address_count;
        offset += 4;
    }

    /* Read the 'IPv4Address' variable */
    {
        if (ipv4_address != NULL)
            *ipv4_address = _mbim_message_read_mbim_ipv4_element_struct_array (message, _ipv4_address_count, offset, FALSE);
        offset += 4;
    }

    /* Read the 'IPv6AddressCount' variable */
    {
        _ipv6_address_count = _mbim_message_read_guint32 (message, offset);
        if (ipv6_address_count != NULL)
            *ipv6_address_count = _ipv6_address_count;
        offset += 4;
    }

    /* Read the 'IPv6Address' variable */
    {
        if (ipv6_address != NULL)
            *ipv6_address = _mbim_message_read_mbim_ipv6_element_struct_array (message, _ipv6_address_count, offset, FALSE);
        offset += 4;
    }

    /* Read the 'IPv4Gateway' variable */
    {
        if (ipv4_gateway != NULL)
            *ipv4_gateway =  _mbim_message_read_ipv4 (message, offset, TRUE);
        offset += 4;
    }

    /* Read the 'IPv6Gateway' variable */
    {
        if (ipv6_gateway != NULL)
            *ipv6_gateway =  _mbim_message_read_ipv6 (message, offset, TRUE);
        offset += 4;
    }

    /* Read the 'IPv4DnsServerCount' variable */
    {
        _ipv4_dns_server_count = _mbim_message_read_guint32 (message, offset);
        if (ipv4_dns_server_count != NULL)
            *ipv4_dns_server_count = _ipv4_dns_server_count;
        offset += 4;
    }

    /* Read the 'IPv4DnsServer' variable */
    {
        if (ipv4_dns_server != NULL)
            *ipv4_dns_server =  _mbim_message_read_ipv4_array (message, _ipv4_dns_server_count, offset);
        offset += 4;
    }

    /* Read the 'IPv6DnsServerCount' variable */
    {
        _ipv6_dns_server_count = _mbim_message_read_guint32 (message, offset);
        if (ipv6_dns_server_count != NULL)
            *ipv6_dns_server_count = _ipv6_dns_server_count;
        offset += 4;
    }

    /* Read the 'IPv6DnsServer' variable */
    {
        if (ipv6_dns_server != NULL)
            *ipv6_dns_server =  _mbim_message_read_ipv6_array (message, _ipv6_dns_server_count, offset);
        offset += 4;
    }

    /* Read the 'IPv4Mtu' variable */
    {
        if (ipv4_mtu != NULL)
            *ipv4_mtu =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'IPv6Mtu' variable */
    {
        if (ipv6_mtu != NULL)
            *ipv6_mtu =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_ip_configuration_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _ipv4_address_count;
    guint32 _ipv6_address_count;
    guint32 _ipv4_dns_server_count;
    guint32 _ipv6_dns_server_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4ConfigurationAvailable = ", line_prefix);
    {
        MbimIPConfigurationAvailableFlag tmp;

        tmp = (MbimIPConfigurationAvailableFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ip_configuration_available_flag_get_string (tmp));
#elif defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ip_configuration_available_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6ConfigurationAvailable = ", line_prefix);
    {
        MbimIPConfigurationAvailableFlag tmp;

        tmp = (MbimIPConfigurationAvailableFlag) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_ip_configuration_available_flag_get_string (tmp));
#elif defined __MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_ip_configuration_available_flag_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4AddressCount = ", line_prefix);
    {
        _ipv4_address_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv4_address_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Address = ", line_prefix);
    {
        MbimIPv4Element **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_ipv4_element_struct_array (message, _ipv4_address_count, offset, FALSE);
        offset += 4;
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _ipv4_address_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_ipv4_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_ipv4_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6AddressCount = ", line_prefix);
    {
        _ipv6_address_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv6_address_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Address = ", line_prefix);
    {
        MbimIPv6Element **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_ipv6_element_struct_array (message, _ipv6_address_count, offset, FALSE);
        offset += 4;
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _ipv6_address_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_ipv6_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_ipv6_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Gateway = ", line_prefix);
    {
        const MbimIPv4 *tmp;
        guint array_size;
        guint i;

        array_size = 1;
        tmp = _mbim_message_read_ipv4 (message, offset, TRUE);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV4);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Gateway = ", line_prefix);
    {
        const MbimIPv6 *tmp;
        guint array_size;
        guint i;

        array_size = 1;
        tmp = _mbim_message_read_ipv6 (message, offset, TRUE);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV6);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4DnsServerCount = ", line_prefix);
    {
        _ipv4_dns_server_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv4_dns_server_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4DnsServer = ", line_prefix);
    {
        MbimIPv4 *tmp;
        guint array_size;
        guint i;

        array_size = _ipv4_dns_server_count;
        tmp = _mbim_message_read_ipv4_array (message, _ipv4_dns_server_count, offset);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV4);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6DnsServerCount = ", line_prefix);
    {
        _ipv6_dns_server_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _ipv6_dns_server_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6DnsServer = ", line_prefix);
    {
        MbimIPv6 *tmp;
        guint array_size;
        guint i;

        array_size = _ipv6_dns_server_count;
        tmp = _mbim_message_read_ipv6_array (message, _ipv6_dns_server_count, offset);
        offset += 4;
        g_string_append (str, "'");
        if (tmp) {
            for (i = 0; i < array_size; i++) {
                GInetAddress *addr;
                gchar *tmpstr;

                addr = g_inet_address_new_from_bytes ((guint8 *)&(tmp[i].addr), G_SOCKET_FAMILY_IPV6);
                tmpstr = g_inet_address_to_string (addr);
                g_string_append_printf (str, "%s", tmpstr);
                g_free (tmpstr);
                g_object_unref (addr);
                if (i < (array_size - 1))
                    g_string_append (str, ", ");
            }
        }
        g_string_append (str, "'");
        g_free (tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv4Mtu = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  IPv6Mtu = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Device Services */

/**
 * mbim_message_device_services_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Device Services' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_device_services_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_DEVICE_SERVICES,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_device_services_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Device Services */

/**
 * mbim_message_device_services_response_parse:
 * @message: the #MbimMessage.
 * @device_services_count: return location for a #guint32, or %NULL if the 'DeviceServicesCount' field is not needed.
 * @max_dss_sessions: return location for a #guint32, or %NULL if the 'MaxDssSessions' field is not needed.
 * @device_services: return location for a newly allocated array of #MbimDeviceServiceElements, or %NULL if the 'DeviceServices' field is not needed. Free the returned value with mbim_device_service_element_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Device Services' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_device_services_response_parse (
    const MbimMessage *message,
    guint32 *device_services_count,
    guint32 *max_dss_sessions,
    MbimDeviceServiceElement ***device_services,
    GError **error)
{
    guint32 offset = 0;
    guint32 _device_services_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'DeviceServicesCount' variable */
    {
        _device_services_count = _mbim_message_read_guint32 (message, offset);
        if (device_services_count != NULL)
            *device_services_count = _device_services_count;
        offset += 4;
    }

    /* Read the 'MaxDssSessions' variable */
    {
        if (max_dss_sessions != NULL)
            *max_dss_sessions =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'DeviceServices' variable */
    {
        if (device_services != NULL)
            *device_services = _mbim_message_read_mbim_device_service_element_struct_array (message, _device_services_count, offset, TRUE);
        offset += (8 * _device_services_count);
    }

    return TRUE;
}

static gchar *
mbim_message_device_services_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _device_services_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  DeviceServicesCount = ", line_prefix);
    {
        _device_services_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _device_services_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  MaxDssSessions = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  DeviceServices = ", line_prefix);
    {
        MbimDeviceServiceElement **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_device_service_element_struct_array (message, _device_services_count, offset, TRUE);
        offset += (8 * _device_services_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _device_services_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_device_service_element_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_device_service_element_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Device Service Subscribe List */

/**
 * mbim_message_device_service_subscribe_list_set_new:
 * @events_count: the 'EventsCount' field, given as a #guint32.
 * @events: the 'Events' field, given as an array of #MbimEventEntrys.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Device Service Subscribe List' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_device_service_subscribe_list_set_new (
    guint32 events_count,
    const MbimEventEntry *const *events,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_DEVICE_SERVICE_SUBSCRIBE_LIST,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, events_count);
    }
    {
        _mbim_message_command_builder_append_mbim_event_entry_struct_array (builder, events, events_count, TRUE);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_device_service_subscribe_list_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _events_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  EventsCount = ", line_prefix);
    {
        _events_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _events_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Events = ", line_prefix);
    {
        MbimEventEntry **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_event_entry_struct_array (message, _events_count, offset, TRUE);
        offset += (8 * _events_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _events_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_event_entry_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_event_entry_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Device Service Subscribe List */

/**
 * mbim_message_device_service_subscribe_list_response_parse:
 * @message: the #MbimMessage.
 * @events_count: return location for a #guint32, or %NULL if the 'EventsCount' field is not needed.
 * @events: return location for a newly allocated array of #MbimEventEntrys, or %NULL if the 'Events' field is not needed. Free the returned value with mbim_event_entry_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Device Service Subscribe List' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_device_service_subscribe_list_response_parse (
    const MbimMessage *message,
    guint32 *events_count,
    MbimEventEntry ***events,
    GError **error)
{
    guint32 offset = 0;
    guint32 _events_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'EventsCount' variable */
    {
        _events_count = _mbim_message_read_guint32 (message, offset);
        if (events_count != NULL)
            *events_count = _events_count;
        offset += 4;
    }

    /* Read the 'Events' variable */
    {
        if (events != NULL)
            *events = _mbim_message_read_mbim_event_entry_struct_array (message, _events_count, offset, TRUE);
        offset += (8 * _events_count);
    }

    return TRUE;
}

static gchar *
mbim_message_device_service_subscribe_list_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _events_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  EventsCount = ", line_prefix);
    {
        _events_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _events_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Events = ", line_prefix);
    {
        MbimEventEntry **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_event_entry_struct_array (message, _events_count, offset, TRUE);
        offset += (8 * _events_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _events_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_event_entry_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_event_entry_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Packet Statistics */

/**
 * mbim_message_packet_statistics_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Packet Statistics' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_packet_statistics_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_PACKET_STATISTICS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_packet_statistics_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Packet Statistics */

/**
 * mbim_message_packet_statistics_response_parse:
 * @message: the #MbimMessage.
 * @in_discards: return location for a #guint32, or %NULL if the 'InDiscards' field is not needed.
 * @in_errors: return location for a #guint32, or %NULL if the 'InErrors' field is not needed.
 * @in_octets: return location for a #guint64, or %NULL if the 'InOctets' field is not needed.
 * @in_packets: return location for a #guint64, or %NULL if the 'InPackets' field is not needed.
 * @out_octets: return location for a #guint64, or %NULL if the 'OutOctets' field is not needed.
 * @out_packets: return location for a #guint64, or %NULL if the 'OutPackets' field is not needed.
 * @out_errors: return location for a #guint32, or %NULL if the 'OutErrors' field is not needed.
 * @out_discards: return location for a #guint32, or %NULL if the 'OutDiscards' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Packet Statistics' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_packet_statistics_response_parse (
    const MbimMessage *message,
    guint32 *in_discards,
    guint32 *in_errors,
    guint64 *in_octets,
    guint64 *in_packets,
    guint64 *out_octets,
    guint64 *out_packets,
    guint32 *out_errors,
    guint32 *out_discards,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'InDiscards' variable */
    {
        if (in_discards != NULL)
            *in_discards =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'InErrors' variable */
    {
        if (in_errors != NULL)
            *in_errors =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'InOctets' variable */
    {
        if (in_octets != NULL)
            *in_octets =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    /* Read the 'InPackets' variable */
    {
        if (in_packets != NULL)
            *in_packets =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    /* Read the 'OutOctets' variable */
    {
        if (out_octets != NULL)
            *out_octets =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    /* Read the 'OutPackets' variable */
    {
        if (out_packets != NULL)
            *out_packets =  _mbim_message_read_guint64 (message, offset);
        offset += 8;
    }

    /* Read the 'OutErrors' variable */
    {
        if (out_errors != NULL)
            *out_errors =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'OutDiscards' variable */
    {
        if (out_discards != NULL)
            *out_discards =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_packet_statistics_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  InDiscards = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  InErrors = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  InOctets = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  InPackets = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  OutOctets = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  OutPackets = ", line_prefix);
    {
        guint64 tmp;

        tmp = (guint64) _mbim_message_read_guint64 (message, offset);
        offset += 8;
        g_string_append_printf (str, "'%" G_GUINT64_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  OutErrors = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  OutDiscards = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Network Idle Hint */

/**
 * mbim_message_network_idle_hint_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Network Idle Hint' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_network_idle_hint_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_NETWORK_IDLE_HINT,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_network_idle_hint_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Network Idle Hint */

/**
 * mbim_message_network_idle_hint_set_new:
 * @state: the 'State' field, given as a #MbimNetworkIdleHintState.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Network Idle Hint' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_network_idle_hint_set_new (
    MbimNetworkIdleHintState state,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_NETWORK_IDLE_HINT,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, state);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_network_idle_hint_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  State = ", line_prefix);
    {
        MbimNetworkIdleHintState tmp;

        tmp = (MbimNetworkIdleHintState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_NETWORK_IDLE_HINT_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_network_idle_hint_state_get_string (tmp));
#elif defined __MBIM_NETWORK_IDLE_HINT_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_network_idle_hint_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Network Idle Hint */

/**
 * mbim_message_network_idle_hint_response_parse:
 * @message: the #MbimMessage.
 * @state: return location for a #MbimNetworkIdleHintState, or %NULL if the 'State' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Network Idle Hint' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_network_idle_hint_response_parse (
    const MbimMessage *message,
    MbimNetworkIdleHintState *state,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'State' variable */
    {
        if (state != NULL)
            *state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_network_idle_hint_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  State = ", line_prefix);
    {
        MbimNetworkIdleHintState tmp;

        tmp = (MbimNetworkIdleHintState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_NETWORK_IDLE_HINT_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_network_idle_hint_state_get_string (tmp));
#elif defined __MBIM_NETWORK_IDLE_HINT_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_network_idle_hint_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Emergency Mode */

/**
 * mbim_message_emergency_mode_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Emergency Mode' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_emergency_mode_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_EMERGENCY_MODE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_emergency_mode_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Emergency Mode */

/**
 * mbim_message_emergency_mode_set_new:
 * @state: the 'State' field, given as a #MbimEmergencyModeState.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Emergency Mode' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_emergency_mode_set_new (
    MbimEmergencyModeState state,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_EMERGENCY_MODE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, state);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_emergency_mode_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  State = ", line_prefix);
    {
        MbimEmergencyModeState tmp;

        tmp = (MbimEmergencyModeState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_EMERGENCY_MODE_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_emergency_mode_state_get_string (tmp));
#elif defined __MBIM_EMERGENCY_MODE_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_emergency_mode_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Emergency Mode */

/**
 * mbim_message_emergency_mode_response_parse:
 * @message: the #MbimMessage.
 * @state: return location for a #MbimEmergencyModeState, or %NULL if the 'State' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Emergency Mode' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_emergency_mode_response_parse (
    const MbimMessage *message,
    MbimEmergencyModeState *state,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'State' variable */
    {
        if (state != NULL)
            *state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_emergency_mode_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  State = ", line_prefix);
    {
        MbimEmergencyModeState tmp;

        tmp = (MbimEmergencyModeState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_EMERGENCY_MODE_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_emergency_mode_state_get_string (tmp));
#elif defined __MBIM_EMERGENCY_MODE_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_emergency_mode_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Emergency Mode */

/**
 * mbim_message_emergency_mode_notification_parse:
 * @message: the #MbimMessage.
 * @state: return location for a #MbimEmergencyModeState, or %NULL if the 'State' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Emergency Mode' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_emergency_mode_notification_parse (
    const MbimMessage *message,
    MbimEmergencyModeState *state,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'State' variable */
    {
        if (state != NULL)
            *state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

static gchar *
mbim_message_emergency_mode_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  State = ", line_prefix);
    {
        MbimEmergencyModeState tmp;

        tmp = (MbimEmergencyModeState) _mbim_message_read_guint32 (message, offset);
        offset += 4;
#if defined __MBIM_EMERGENCY_MODE_STATE_IS_ENUM__
        g_string_append_printf (str, "'%s'", mbim_emergency_mode_state_get_string (tmp));
#elif defined __MBIM_EMERGENCY_MODE_STATE_IS_FLAGS__
        {
            gchar *tmpstr;

            tmpstr = mbim_emergency_mode_state_build_string_from_mask (tmp);
            g_string_append_printf (str, "'%s'", tmpstr);
            g_free (tmpstr);
        }
#else
# error neither enum nor flags
#endif

    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message IP Packet Filters */

/**
 * mbim_message_ip_packet_filters_query_new:
 * @session_id: the 'SessionId' field, given as a #guint32.
 * @packet_filters_count: the 'PacketFiltersCount' field, given as a #guint32.
 * @packet_filters: the 'PacketFilters' field, given as an array of #MbimPacketFilters.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'IP Packet Filters' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_ip_packet_filters_query_new (
    guint32 session_id,
    guint32 packet_filters_count,
    const MbimPacketFilter *const *packet_filters,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_IP_PACKET_FILTERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);
    {
        _mbim_message_command_builder_append_guint32 (builder, session_id);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, packet_filters_count);
    }
    {
        _mbim_message_command_builder_append_mbim_packet_filter_struct_array (builder, packet_filters, packet_filters_count, TRUE);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_ip_packet_filters_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _packet_filters_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketFiltersCount = ", line_prefix);
    {
        _packet_filters_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _packet_filters_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketFilters = ", line_prefix);
    {
        MbimPacketFilter **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_packet_filter_struct_array (message, _packet_filters_count, offset, TRUE);
        offset += (8 * _packet_filters_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _packet_filters_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_packet_filter_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_packet_filter_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message IP Packet Filters */

/**
 * mbim_message_ip_packet_filters_set_new:
 * @session_id: the 'SessionId' field, given as a #guint32.
 * @packet_filters_count: the 'PacketFiltersCount' field, given as a #guint32.
 * @packet_filters: the 'PacketFilters' field, given as an array of #MbimPacketFilters.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'IP Packet Filters' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_ip_packet_filters_set_new (
    guint32 session_id,
    guint32 packet_filters_count,
    const MbimPacketFilter *const *packet_filters,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_IP_PACKET_FILTERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, session_id);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, packet_filters_count);
    }
    {
        _mbim_message_command_builder_append_mbim_packet_filter_struct_array (builder, packet_filters, packet_filters_count, TRUE);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_ip_packet_filters_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _packet_filters_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketFiltersCount = ", line_prefix);
    {
        _packet_filters_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _packet_filters_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketFilters = ", line_prefix);
    {
        MbimPacketFilter **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_packet_filter_struct_array (message, _packet_filters_count, offset, TRUE);
        offset += (8 * _packet_filters_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _packet_filters_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_packet_filter_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_packet_filter_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message IP Packet Filters */

/**
 * mbim_message_ip_packet_filters_response_parse:
 * @message: the #MbimMessage.
 * @session_id: return location for a #guint32, or %NULL if the 'SessionId' field is not needed.
 * @packet_filters_count: return location for a #guint32, or %NULL if the 'PacketFiltersCount' field is not needed.
 * @packet_filters: return location for a newly allocated array of #MbimPacketFilters, or %NULL if the 'PacketFilters' field is not needed. Free the returned value with mbim_packet_filter_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'IP Packet Filters' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_ip_packet_filters_response_parse (
    const MbimMessage *message,
    guint32 *session_id,
    guint32 *packet_filters_count,
    MbimPacketFilter ***packet_filters,
    GError **error)
{
    guint32 offset = 0;
    guint32 _packet_filters_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'SessionId' variable */
    {
        if (session_id != NULL)
            *session_id =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'PacketFiltersCount' variable */
    {
        _packet_filters_count = _mbim_message_read_guint32 (message, offset);
        if (packet_filters_count != NULL)
            *packet_filters_count = _packet_filters_count;
        offset += 4;
    }

    /* Read the 'PacketFilters' variable */
    {
        if (packet_filters != NULL)
            *packet_filters = _mbim_message_read_mbim_packet_filter_struct_array (message, _packet_filters_count, offset, TRUE);
        offset += (8 * _packet_filters_count);
    }

    return TRUE;
}

static gchar *
mbim_message_ip_packet_filters_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _packet_filters_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  SessionId = ", line_prefix);
    {
        guint32 tmp;

        tmp = (guint32) _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", tmp);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketFiltersCount = ", line_prefix);
    {
        _packet_filters_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _packet_filters_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  PacketFilters = ", line_prefix);
    {
        MbimPacketFilter **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_packet_filter_struct_array (message, _packet_filters_count, offset, TRUE);
        offset += (8 * _packet_filters_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _packet_filters_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_packet_filter_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_packet_filter_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Multicarrier Providers */

/**
 * mbim_message_multicarrier_providers_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Multicarrier Providers' query command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_multicarrier_providers_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_MULTICARRIER_PROVIDERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_multicarrier_providers_query_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;

    str = g_string_new ("");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Set): MBIM Message Multicarrier Providers */

/**
 * mbim_message_multicarrier_providers_set_new:
 * @providers_count: the 'ProvidersCount' field, given as a #guint32.
 * @providers: the 'Providers' field, given as an array of #MbimProviders.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Multicarrier Providers' set command in the 'Basic Connect' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_multicarrier_providers_set_new (
    guint32 providers_count,
    const MbimProvider *const *providers,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_BASIC_CONNECT,
                                                 MBIM_CID_BASIC_CONNECT_MULTICARRIER_PROVIDERS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, providers_count);
    }
    {
        _mbim_message_command_builder_append_mbim_provider_struct_array (builder, providers, providers_count, TRUE);
    }

    return _mbim_message_command_builder_complete (builder);
}

static gchar *
mbim_message_multicarrier_providers_set_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Multicarrier Providers */

/**
 * mbim_message_multicarrier_providers_response_parse:
 * @message: the #MbimMessage.
 * @providers_count: return location for a #guint32, or %NULL if the 'ProvidersCount' field is not needed.
 * @providers: return location for a newly allocated array of #MbimProviders, or %NULL if the 'Providers' field is not needed. Free the returned value with mbim_provider_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Multicarrier Providers' response command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_multicarrier_providers_response_parse (
    const MbimMessage *message,
    guint32 *providers_count,
    MbimProvider ***providers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _providers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'ProvidersCount' variable */
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        if (providers_count != NULL)
            *providers_count = _providers_count;
        offset += 4;
    }

    /* Read the 'Providers' variable */
    {
        if (providers != NULL)
            *providers = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_multicarrier_providers_response_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    if (!mbim_message_response_get_result (message, MBIM_MESSAGE_TYPE_COMMAND_DONE, NULL))
        return NULL;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Multicarrier Providers */

/**
 * mbim_message_multicarrier_providers_notification_parse:
 * @message: the #MbimMessage.
 * @providers_count: return location for a #guint32, or %NULL if the 'ProvidersCount' field is not needed.
 * @providers: return location for a newly allocated array of #MbimProviders, or %NULL if the 'Providers' field is not needed. Free the returned value with mbim_provider_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Multicarrier Providers' notification command in the 'Basic Connect' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_multicarrier_providers_notification_parse (
    const MbimMessage *message,
    guint32 *providers_count,
    MbimProvider ***providers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _providers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'ProvidersCount' variable */
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        if (providers_count != NULL)
            *providers_count = _providers_count;
        offset += 4;
    }

    /* Read the 'Providers' variable */
    {
        if (providers != NULL)
            *providers = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
    }

    return TRUE;
}

static gchar *
mbim_message_multicarrier_providers_notification_get_printable (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    GString *str;
    guint32 offset = 0;
    guint32 _providers_count;

    str = g_string_new ("");

    g_string_append_printf (str, "%s  ProvidersCount = ", line_prefix);
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        offset += 4;
        g_string_append_printf (str, "'%" G_GUINT32_FORMAT "'", _providers_count);
    }
    g_string_append (str, "\n");

    g_string_append_printf (str, "%s  Providers = ", line_prefix);
    {
        MbimProvider **tmp;
        gchar *new_line_prefix;
        guint i;

        tmp = _mbim_message_read_mbim_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
        new_line_prefix = g_strdup_printf ("%s        ", line_prefix);
        g_string_append (str, "'{\n");
        for (i = 0; i < _providers_count; i++) {
            gchar *struct_str;

            g_string_append_printf (str, "%s    [%u] = {\n", line_prefix, i);
            struct_str = _mbim_message_print_mbim_provider_struct (tmp[i], new_line_prefix);
            g_string_append (str, struct_str);
            g_free (struct_str);
            g_string_append_printf (str, "%s    },\n", line_prefix);
        }
        g_string_append_printf (str, "%s  }'", line_prefix);
        g_free (new_line_prefix);
        mbim_provider_array_free (tmp);
    }
    g_string_append (str, "\n");

    return g_string_free (str, FALSE);
}

typedef struct {
  gchar * (* query_cb)        (const MbimMessage *message, const gchar *line_prefix, GError **error);
  gchar * (* set_cb)          (const MbimMessage *message, const gchar *line_prefix, GError **error);
  gchar * (* response_cb)     (const MbimMessage *message, const gchar *line_prefix, GError **error);
  gchar * (* notification_cb) (const MbimMessage *message, const gchar *line_prefix, GError **error);
} GetPrintableCallbacks;

static const GetPrintableCallbacks get_printable_callbacks[] = {
    [MBIM_CID_BASIC_CONNECT_DEVICE_CAPS] = {
        .query_cb = mbim_message_device_caps_query_get_printable,
        .response_cb = mbim_message_device_caps_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_SUBSCRIBER_READY_STATUS] = {
        .query_cb = mbim_message_subscriber_ready_status_query_get_printable,
        .response_cb = mbim_message_subscriber_ready_status_response_get_printable,
        .notification_cb = mbim_message_subscriber_ready_status_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_RADIO_STATE] = {
        .query_cb = mbim_message_radio_state_query_get_printable,
        .set_cb = mbim_message_radio_state_set_get_printable,
        .response_cb = mbim_message_radio_state_response_get_printable,
        .notification_cb = mbim_message_radio_state_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_PIN] = {
        .query_cb = mbim_message_pin_query_get_printable,
        .set_cb = mbim_message_pin_set_get_printable,
        .response_cb = mbim_message_pin_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_PIN_LIST] = {
        .query_cb = mbim_message_pin_list_query_get_printable,
        .response_cb = mbim_message_pin_list_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_HOME_PROVIDER] = {
        .query_cb = mbim_message_home_provider_query_get_printable,
        .set_cb = mbim_message_home_provider_set_get_printable,
        .response_cb = mbim_message_home_provider_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_PREFERRED_PROVIDERS] = {
        .query_cb = mbim_message_preferred_providers_query_get_printable,
        .set_cb = mbim_message_preferred_providers_set_get_printable,
        .response_cb = mbim_message_preferred_providers_response_get_printable,
        .notification_cb = mbim_message_preferred_providers_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_VISIBLE_PROVIDERS] = {
        .query_cb = mbim_message_visible_providers_query_get_printable,
        .response_cb = mbim_message_visible_providers_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_REGISTER_STATE] = {
        .query_cb = mbim_message_register_state_query_get_printable,
        .set_cb = mbim_message_register_state_set_get_printable,
        .response_cb = mbim_message_register_state_response_get_printable,
        .notification_cb = mbim_message_register_state_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_SIGNAL_STATE] = {
        .query_cb = mbim_message_signal_state_query_get_printable,
        .set_cb = mbim_message_signal_state_set_get_printable,
        .response_cb = mbim_message_signal_state_response_get_printable,
        .notification_cb = mbim_message_signal_state_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_PACKET_SERVICE] = {
        .query_cb = mbim_message_packet_service_query_get_printable,
        .set_cb = mbim_message_packet_service_set_get_printable,
        .response_cb = mbim_message_packet_service_response_get_printable,
        .notification_cb = mbim_message_packet_service_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_CONNECT] = {
        .query_cb = mbim_message_connect_query_get_printable,
        .set_cb = mbim_message_connect_set_get_printable,
        .response_cb = mbim_message_connect_response_get_printable,
        .notification_cb = mbim_message_connect_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_PROVISIONED_CONTEXTS] = {
        .query_cb = mbim_message_provisioned_contexts_query_get_printable,
        .set_cb = mbim_message_provisioned_contexts_set_get_printable,
        .response_cb = mbim_message_provisioned_contexts_response_get_printable,
        .notification_cb = mbim_message_provisioned_contexts_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_SERVICE_ACTIVATION] = {
        .set_cb = mbim_message_service_activation_set_get_printable,
        .response_cb = mbim_message_service_activation_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_IP_CONFIGURATION] = {
        .query_cb = mbim_message_ip_configuration_query_get_printable,
        .response_cb = mbim_message_ip_configuration_response_get_printable,
        .notification_cb = mbim_message_ip_configuration_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_DEVICE_SERVICES] = {
        .query_cb = mbim_message_device_services_query_get_printable,
        .response_cb = mbim_message_device_services_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_DEVICE_SERVICE_SUBSCRIBE_LIST] = {
        .set_cb = mbim_message_device_service_subscribe_list_set_get_printable,
        .response_cb = mbim_message_device_service_subscribe_list_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_PACKET_STATISTICS] = {
        .query_cb = mbim_message_packet_statistics_query_get_printable,
        .response_cb = mbim_message_packet_statistics_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_NETWORK_IDLE_HINT] = {
        .query_cb = mbim_message_network_idle_hint_query_get_printable,
        .set_cb = mbim_message_network_idle_hint_set_get_printable,
        .response_cb = mbim_message_network_idle_hint_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_EMERGENCY_MODE] = {
        .query_cb = mbim_message_emergency_mode_query_get_printable,
        .set_cb = mbim_message_emergency_mode_set_get_printable,
        .response_cb = mbim_message_emergency_mode_response_get_printable,
        .notification_cb = mbim_message_emergency_mode_notification_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_IP_PACKET_FILTERS] = {
        .query_cb = mbim_message_ip_packet_filters_query_get_printable,
        .set_cb = mbim_message_ip_packet_filters_set_get_printable,
        .response_cb = mbim_message_ip_packet_filters_response_get_printable,
    },
    [MBIM_CID_BASIC_CONNECT_MULTICARRIER_PROVIDERS] = {
        .query_cb = mbim_message_multicarrier_providers_query_get_printable,
        .set_cb = mbim_message_multicarrier_providers_set_get_printable,
        .response_cb = mbim_message_multicarrier_providers_response_get_printable,
        .notification_cb = mbim_message_multicarrier_providers_notification_get_printable,
    },
};

gchar *
__mbim_message_basic_connect_get_printable_fields (
    const MbimMessage *message,
    const gchar *line_prefix,
    GError **error)
{
    guint32 cid;

    switch (mbim_message_get_message_type (message)) {
        case MBIM_MESSAGE_TYPE_COMMAND: {
            cid = mbim_message_command_get_cid (message);
            if (cid < G_N_ELEMENTS (get_printable_callbacks)) {
                switch (mbim_message_command_get_command_type (message)) {
                    case MBIM_MESSAGE_COMMAND_TYPE_QUERY:
                        if (get_printable_callbacks[cid].query_cb)
                            return get_printable_callbacks[cid].query_cb (message, line_prefix, error);
                        break;
                    case MBIM_MESSAGE_COMMAND_TYPE_SET:
                        if (get_printable_callbacks[cid].set_cb)
                            return get_printable_callbacks[cid].set_cb (message, line_prefix, error);
                        break;
                    default:
                        g_set_error (error,
                                     MBIM_CORE_ERROR,
                                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                                     "Invalid command type");
                        return NULL;
                }
            }
            break;
        }

        case MBIM_MESSAGE_TYPE_COMMAND_DONE:
            cid = mbim_message_command_done_get_cid (message);
            if (cid < G_N_ELEMENTS (get_printable_callbacks)) {
                if (get_printable_callbacks[cid].response_cb)
                    return get_printable_callbacks[cid].response_cb (message, line_prefix, error);
            }
            break;

        case MBIM_MESSAGE_TYPE_INDICATE_STATUS:
            cid = mbim_message_indicate_status_get_cid (message);
            if (cid < G_N_ELEMENTS (get_printable_callbacks)) {
                if (get_printable_callbacks[cid].notification_cb)
                    return get_printable_callbacks[cid].notification_cb (message, line_prefix, error);
            }
            break;

        default:
            g_set_error (error,
                         MBIM_CORE_ERROR,
                         MBIM_CORE_ERROR_INVALID_MESSAGE,
                         "No contents expected in this message type");
            return NULL;
    }

    g_set_error (error,
                 MBIM_CORE_ERROR,
                 MBIM_CORE_ERROR_INVALID_MESSAGE,
                 "Unknown contents");
    return NULL;
}
